'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _element = require('../dom/nodes/element');

var _element2 = _interopRequireDefault(_element);

var _shadowStyle = require('./shadow-style');

var _shadowStyle2 = _interopRequireDefault(_shadowStyle);

var _directive = require('./directive');

var _directive2 = _interopRequireDefault(_directive);

var _map = require('../polyfill/map');

var _map2 = _interopRequireDefault(_map);

var _dom = require('../dom');

var _dom2 = _interopRequireDefault(_dom);

var _tree = require('./tree');

var _tree2 = _interopRequireDefault(_tree);

var _context = require('./context');

var _context2 = _interopRequireDefault(_context);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Component,
    indexOf = [].indexOf;

module.exports = Component = function () {
  var compiledComponents, lastId, shadowStyles;

  var Component = function () {
    function Component() {
      _classCallCheck(this, Component);
    }

    _createClass(Component, [{
      key: 'require',
      value: function require(tag) {
        var context, match, optional, ref, ref1;
        match = tag.match(/(.+?)(\?)?$/);
        tag = match[1];
        optional = !!match[2];
        context = this.host.parent;
        while (context) {
          if (((ref = context.component) != null ? (ref1 = ref.constructor) != null ? ref1.tag : void 0 : void 0) === tag) {
            return context.component;
          }
          context = context.parent;
        }
        if (optional) {
          return null;
        }
        throw Error('Not found parent component \'' + tag + '\' for \'' + this.constructor.tag + '\'');
      }
    }, {
      key: 'emit',
      value: function emit(eventName, event) {
        this.host.emit(eventName, event);
      }
    }, {
      key: 'on',
      value: function on(eventName, handler) {
        this.host.on(eventName, handler);
      }
    }, {
      key: 'one',
      value: function one(eventName, handler) {
        this.host.one(eventName, handler);
      }
    }, {
      key: 'own',
      value: function own(eventName, handler) {
        this.host.own(eventName, handler);
      }
    }, {
      key: 'off',
      value: function off(eventName, handler) {
        this.host.off(eventName, handler);
      }
    }, {
      key: 'bindClass',
      value: function bindClass(className, exp) {
        return this.host.bindClass(className, exp, this, this.scope);
      }
    }, {
      key: 'bind',
      value: function bind(path, exp) {
        return ui.bind(this, path, this, exp, this.scope);
      }
    }, {
      key: 'watch',
      value: function watch(exp, handler, firstCall) {
        return ui.watch(this, exp, handler, null, firstCall);
      }
    }], [{
      key: 'create',
      value: function create(Class) {
        if (indexOf.call(compiledComponents, Class) >= 0) {
          return Class;
        }
        compiledComponents.push(compiledComponents);
        this.extend(Class);
        this.wrap(Class);
        if (Class.hasOwnProperty('tag')) {
          Class.tag = Class.tag.toLowerCase();
        } else {
          Class.tag = Class.name.toLowerCase();
        }
        Class.isComponent = true;
        Class.id = lastId++;
        Class.compile();
        return Class;
      }
    }, {
      key: 'extend',
      value: function extend(Class) {
        var RootClass;
        if (!(Class.prototype instanceof this)) {
          RootClass = this.getRootClass(Class);
          Object.setPrototypeOf(RootClass, this);
          Object.setPrototypeOf(RootClass.prototype, this.prototype);
        }
        return Class;
      }
    }, {
      key: 'wrap',
      value: function wrap(Class) {
        var methodNames, prototype;
        prototype = Class.prototype;
        methodNames = this.getMethodNames(Class);
        methodNames.forEach(function (methodName) {
          var method;
          method = prototype[methodName];
          return Object.defineProperty(prototype, methodName, {
            writable: true,
            configurable: true,
            value: function value() {
              return this.context.apply(method, arguments, this);
            }
          });
        });
      }
    }, {
      key: 'getMethodNames',
      value: function getMethodNames(Class) {
        var i, key, keys, len, methodNames, prototype;
        methodNames = [];
        prototype = Class.prototype;
        while (prototype) {
          keys = Object.getOwnPropertyNames(prototype);
          for (i = 0, len = keys.length; i < len; i++) {
            key = keys[i];
            if (key !== 'constructor') {
              if (typeof prototype[key] === 'function') {
                methodNames.push(key);
              }
            }
          }
          prototype = Object.getPrototypeOf(prototype);
          if (prototype === Object.prototype) {
            break;
          }
        }
        return methodNames;
      }
    }, {
      key: 'getRootClass',
      value: function getRootClass(Class) {
        var proto;
        while (Class) {
          proto = Object.getPrototypeOf(Class.prototype);
          if (proto === Object.prototype) {
            break;
          }
          Class = proto.constructor;
        }
        return Class;
      }
    }, {
      key: 'compile',
      value: function compile() {
        this.compileComponents();
        this.compileDirectives();
        this.compileTemplate();
        this.compileStyle();
      }
    }, {
      key: 'compileComponents',
      value: function compileComponents() {
        this.components = this.components.map(function (Class) {
          return Component.create(Class);
        });
      }
    }, {
      key: 'compileDirectives',
      value: function compileDirectives() {
        this.directives = this.directives.map(function (Class) {
          return _directive2.default.create(Class);
        });
      }
    }, {
      key: 'compileTemplate',
      value: function compileTemplate() {
        var templateNode;
        templateNode = _dom2.default.createElement('template');
        templateNode.html(this.template);
        this.tree = new _tree2.default(templateNode, this);
        this.compiledTemplate = this.tree.template;
      }
    }, {
      key: 'compileStyle',
      value: function compileStyle() {
        var components, css, i, len, ref, shadowStyle, styleNode;
        if (!shadowStyles.has(this)) {
          styleNode = document.createElement('style');
          styleNode.setAttribute('shadow-style', this.tag);
          document.head.appendChild(styleNode);
          shadowStyles.set(this, styleNode);
        }
        css = '';
        ref = this._getStyles();
        for (i = 0, len = ref.length; i < len; i++) {
          shadowStyle = ref[i];
          components = [].concat(_toConsumableArray(ui.components), _toConsumableArray(this.components));
          css += shadowStyle(this.id, [].concat(_toConsumableArray(ui.components), _toConsumableArray(this.components)));
        }
        styleNode = shadowStyles.get(this);
        styleNode.innerHTML = css;
      }
    }, {
      key: '_getStyles',
      value: function _getStyles() {
        var constructor, context, shadowStyle, style, styles;
        styles = [];
        context = this.prototype;
        while (context) {
          constructor = context.constructor;
          if (constructor.hasOwnProperty('style')) {
            style = constructor.style;
            shadowStyle = _shadowStyle2.default.compile(style);
            styles.unshift(shadowStyle);
          }
          context = Object.getPrototypeOf(context);
        }
        return styles;
      }
    }, {
      key: 'getSubComponent',
      value: function getSubComponent(node) {
        var _this = this;

        var component, components, globalComponents, i, len, tag;
        globalComponents = ui.components.filter(function (component) {
          return component !== _this;
        });
        components = globalComponents.concat(this.components);
        for (i = 0, len = components.length; i < len; i++) {
          component = components[i];
          tag = component.tag;
          if (tag === node.tag) {
            return component;
          }
        }
        return null;
      }
    }, {
      key: 'isSubComponent',
      value: function isSubComponent(node) {
        return !!this.getSubComponent(node);
      }
    }, {
      key: 'getDirective',
      value: function getDirective(name) {
        var Dir, i, j, len, len1, ref, ref1;
        ref = this.directives;
        for (i = 0, len = ref.length; i < len; i++) {
          Dir = ref[i];
          if (Dir.attribute === name) {
            return Dir;
          }
        }
        ref1 = ui.directives;
        for (j = 0, len1 = ref1.length; j < len1; j++) {
          Dir = ref1[j];
          if (Dir.attribute === name) {
            return Dir;
          }
        }
        return null;
      }
    }, {
      key: 'find',
      value: function find(node) {
        var shadowPrefix = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

        var tag;
        tag = shadowPrefix ? 'ui-' + this.tag : this.tag;
        return node.querySelectorAll(tag);
      }
    }, {
      key: 'createTemplateNodes',
      value: function createTemplateNodes() {
        return this.compiledTemplate.clone().children;
      }
    }, {
      key: 'define',
      value: function define(component, prop, value) {
        Object.defineProperty(component, prop, {
          value: value,
          writable: false,
          enumerable: false,
          configurable: true
        });
      }
    }, {
      key: 'init',
      value: function init(host) {
        var app = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
        var parentTree = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
        var parentComponent = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
        var parentScope = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : null;
        var beforeConstruct = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : null;

        var component, context, scope, shadowRoot, templateNodes;
        context = new _context2.default(host);
        context.activate();
        templateNodes = this.createTemplateNodes();
        shadowRoot = host.createShadowRoot(this.id);
        shadowRoot.html(templateNodes);
        component = Object.create(this.prototype);
        scope = Object.create(ui.globals);
        this.define(component, 'host', host);
        this.define(component, 'scope', scope);
        this.define(component, 'context', context);
        this.define(component, 'app', app || component);
        host.component = component;
        if (typeof beforeConstruct === "function") {
          beforeConstruct(component);
        }
        component.constructor(_context2.default);
        this.tree.init(shadowRoot, component, scope);
        host.on('destroy', function () {
          if (typeof component.destructor === "function") {
            component.destructor();
          }
          context.destroy();
        });
        context.deactivate();
        return component;
      }
    }, {
      key: 'reloadStyle',
      value: function reloadStyle() {
        this.compileStyle();
      }
    }, {
      key: 'reloadTemplate',
      value: function reloadTemplate() {
        console.log('reloadTemplate');
      }
    }, {
      key: 'reload',
      value: function reload() {
        console.log('reload');
      }
    }]);

    return Component;
  }();

  ;

  Component.tag = '';

  Component.template = '';

  Component.style = '';

  Component.components = [];

  Component.directives = [];

  Component.id = 0;

  Component.tree = null;

  Component.compiledTemplate = '';

  lastId = 0;

  compiledComponents = [];

  shadowStyles = new _map2.default();

  return Component;
}();