'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _context = require('./context');

var _context2 = _interopRequireDefault(_context);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var EventEmitter, eventHandlers;

eventHandlers = Symbol('eventHandlers');

module.exports = EventEmitter = function () {
  function EventEmitter() {
    _classCallCheck(this, EventEmitter);

    this[eventHandlers] = {};
    return;
  }

  _createClass(EventEmitter, [{
    key: 'on',
    value: function on(type, handler) {
      var _this2 = this;

      var allHandlers, handlers;
      handler = _context2.default.wrap(handler);
      allHandlers = this[eventHandlers];
      handlers = allHandlers[type] || (allHandlers[type] = []);
      handlers.push(handler);
      _context2.default.destroy(function () {
        return _this2.off(type, handler);
      });
      return this;
    }
  }, {
    key: 'one',
    value: function one(type, handler) {
      var _this, _wrapper;
      _this = this;
      this.on(type, _wrapper = function wrapper() {
        var returns;
        returns = handler.apply(this, arguments);
        _this.off(type, _wrapper);
        return returns;
      });
      return this;
    }
  }, {
    key: 'off',
    value: function off(type, handler) {
      var allHandlers, handlers;
      if (!this[eventHandlers]) {
        return;
      }
      handler = _context2.default.wrap(handler);
      allHandlers = this[eventHandlers];
      handlers = allHandlers[type];
      if (!handlers) {
        return;
      }
      if (!handler) {
        delete allHandlers[type];
      } else {
        handlers = handlers.filter(function (setHandler) {
          return setHandler !== handler;
        });
        allHandlers[type] = handlers;
      }
      return this;
    }
  }, {
    key: 'emit',
    value: function emit(type, data) {
      var handler, handlers, i, len, ref;
      if (!this[eventHandlers]) {
        return;
      }
      handlers = this[eventHandlers][type];
      if (!handlers) {
        return;
      }
      ref = handlers.slice();
      for (i = 0, len = ref.length; i < len; i++) {
        handler = ref[i];
        handler(data);
      }
      return this;
    }
  }, {
    key: 'hasEventHandlers',
    value: function hasEventHandlers(type) {
      if (!this[eventHandlers][type]) {
        return false;
      }
      return this[eventHandlers][type].length > 0;
    }
  }, {
    key: 'removeAllEventHandlers',
    value: function removeAllEventHandlers() {
      delete this[eventHandlers];
      return this;
    }
  }]);

  return EventEmitter;
}();