'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

(function () {
  var Selection;

  module.exports = Selection = function () {
    function Selection() {
      _classCallCheck(this, Selection);

      this.selection = getSelection();
      this.activeElement = null;
      this.selectable = false;
      this.selectionStart = 0;
      this.selectionEnd = 0;
      this.ranges = [];
      return;
    }

    _createClass(Selection, [{
      key: 'clear',
      value: function clear() {
        this.anchorNode = null;
        this.anchorOffset = null;
        this.focusNode = null;
        this.focusOffset = null;
      }
    }, {
      key: 'save',
      value: function save() {
        var index, range;
        return;
        this.activeElement = document.activeElement;
        this.selectable = this.isSelectable(this.activeElement);
        if (this.selectable) {
          this.selectionStart = this.activeElement.selectionStart;
          this.selectionEnd = this.activeElement.selectionEnd;
        } else {
          this.ranges = function () {
            var i, ref, results;
            results = [];
            for (index = i = 0, ref = this.selection.rangeCount; 0 <= ref ? i < ref : i > ref; index = 0 <= ref ? ++i : --i) {
              range = this.selection.getRangeAt(index);
              results.push({
                startContainer: range.startContainer,
                startOffset: range.startOffset,
                endContainer: range.endContainer,
                endOffset: range.endOffset
              });
            }
            return results;
          }.call(this);
        }
      }
    }, {
      key: 'restore',
      value: function restore() {
        var activeElement;
        return;
        if (!this.activeElement.id) {
          return;
        }
        activeElement = document.getElementById(this.activeElement.id);
        if (!activeElement) {
          return;
        }
        if (this.selectable) {
          if (activeElement !== document.activeElement) {
            activeElement.focus();
          }
          activeElement.selectionStart = this.selectionStart;
          activeElement.selectionEnd = this.selectionEnd;
        } else {
          return;
        }
      }
    }, {
      key: 'isSelectable',
      value: function isSelectable(node) {
        if (!node) {
          return false;
        }
        if (node.tagName === 'INPUT') {
          return (/^(text|search|password|tel|url)$/.test(node.type)
          );
        }
        if (node.tagName === 'TEXTAREA') {
          return true;
        }
        return false;
      }
    }]);

    return Selection;
  }();
}).call(undefined);