'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

(function () {
  var ShadowStyle, replaceFunc;

  replaceFunc = function replaceFunc(selector, id) {
    var components = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];

    var componentTags, i, len, part, parts, result, separatorRegExp, separators;
    componentTags = components.map(function (component) {
      return component.tag;
    });
    separatorRegExp = /\s+|>/img;
    parts = selector.split(separatorRegExp).map(function (part, index, parts) {
      if (index === parts.length - 1 && !/:host/.test(part)) {
        part = part.replace(/^(.+?)(:.+)?$/, '$1[c' + id + ']$2');
      }
      part = part.replace(/:host/img, '[h' + id + ']');
      part = part.replace(/^[\w\-]+/, function (tag) {
        if (componentTags.indexOf(tag) !== -1) {
          return 'ui-' + tag;
        }
        return tag;
      });
      return part;
    });
    separators = selector.match(separatorRegExp) || [];
    result = '';
    for (i = 0, len = parts.length; i < len; i++) {
      part = parts[i];
      result += part;
      result += separators.pop() || '';
    }
    return result;
  };

  module.exports = ShadowStyle = function () {
    var cache, cssBlockRegExp, partsRegExp;

    var ShadowStyle = function () {
      function ShadowStyle() {
        _classCallCheck(this, ShadowStyle);
      }

      _createClass(ShadowStyle, null, [{
        key: 'compile',
        value: function compile(style) {
          var generator;
          if (typeof style === 'function') {
            return style;
          }
          style = style.toString();
          if (cache[style]) {
            return cache[style];
          }
          generator = this.createStyleGenerator(style);
          generator.style = style;
          cache[style] = generator;
          return generator;
        }
      }, {
        key: 'createStyleGenerator',
        value: function createStyleGenerator(style) {
          var generatorArgs, generatorBody;
          style = style.replace(/\s*(\r|\n|\r\n)\s*/img, '');
          style = style.replace(/"/img, '\\"');
          style = style.replace(cssBlockRegExp, function (match, selector, rules) {
            selector = selector.replace(partsRegExp, '" + replace("$1", id, components) + "');
            return selector + rules;
          });
          generatorArgs = 'id, components';
          generatorBody = 'var replace = ' + replaceFunc + '; return "' + style + '"';
          return new Function(generatorArgs, generatorBody);
        }
      }]);

      return ShadowStyle;
    }();

    ;

    cssBlockRegExp = /([\s\S]+?)\s*({[\s\S]*?})/img;

    partsRegExp = /([^,]+)/img;

    cache = {};

    return ShadowStyle;
  }();
}).call(undefined);