'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

(function () {
  var ArrayCompare, ArrayObserver, DirectArrayObserver;

  ArrayCompare = require('./array-compare');

  module.exports = ArrayObserver = function () {
    _createClass(ArrayObserver, null, [{
      key: 'diff',
      value: function diff(arr, oldArr) {
        return ArrayCompare.calculateSplices(arr, oldArr);
      }
    }]);

    function ArrayObserver(arr1, handler) {
      _classCallCheck(this, ArrayObserver);

      this.arr = arr1;
      this.handler = handler;
      this.directObserver = new DirectArrayObserver(this.arr);
      this.directObserver.addSubObserver(this);
      return;
    }

    _createClass(ArrayObserver, [{
      key: 'destroy',
      value: function destroy() {
        this.directObserver.removeSubObserver(this);
      }
    }]);

    return ArrayObserver;
  }();

  DirectArrayObserver = function () {
    var methodNames, observersMap;

    var DirectArrayObserver = function () {
      function DirectArrayObserver(arr1) {
        _classCallCheck(this, DirectArrayObserver);

        this.push = this.push.bind(this);
        this.pop = this.pop.bind(this);
        this.unshift = this.unshift.bind(this);
        this.shift = this.shift.bind(this);
        this.splice = this.splice.bind(this);
        this.reverse = this.reverse.bind(this);
        this.fill = this.fill.bind(this);
        this.sort = this.sort.bind(this);
        this.arr = arr1;
        if (observersMap.has(this.arr)) {
          return observersMap.get(this.arr);
        }
        observersMap.set(this.arr, this);
        this.subObservers = [];
        this.proto = Object.getPrototypeOf(this.arr);
        return;
      }

      _createClass(DirectArrayObserver, [{
        key: 'destroy',
        value: function destroy() {
          observersMap.delete(this);
          this.disableTrap();
        }
      }, {
        key: 'addSubObserver',
        value: function addSubObserver(subObserver) {
          this.subObservers.push(subObserver);
          if (this.subObservers.length === 1) {
            this.enableTrap();
          }
        }
      }, {
        key: 'removeSubObserver',
        value: function removeSubObserver(subObserver) {
          var index;
          index = this.subObservers.indexOf(subObserver);
          if (index === -1) {
            return;
          }
          this.subObservers.splice(index, 1);
          if (this.subObservers.length === 0) {
            this.destroy();
          }
        }
      }, {
        key: 'enableTrap',
        value: function enableTrap() {
          var i, len, methodName;
          for (i = 0, len = methodNames.length; i < len; i++) {
            methodName = methodNames[i];
            Object.defineProperty(this.arr, methodName, {
              value: this[methodName],
              configurable: true
            });
          }
        }
      }, {
        key: 'disableTrap',
        value: function disableTrap() {
          var i, len, methodName;
          for (i = 0, len = methodNames.length; i < len; i++) {
            methodName = methodNames[i];
            delete this.arr[methodName];
          }
        }
      }, {
        key: 'callOriginal',
        value: function callOriginal(methodName, args) {
          return this.proto[methodName].apply(this.arr, args);
        }
      }, {
        key: 'createSplice',
        value: function createSplice(index, removedCount, addedCount) {
          var removed;
          removed = this.arr.slice(index, index + removedCount);
          return { index: index, addedCount: addedCount, removed: removed };
        }
      }, {
        key: 'callHandlers',
        value: function callHandlers(splices) {
          var i, len, ref, subObserver;
          ref = this.subObservers.slice();
          for (i = 0, len = ref.length; i < len; i++) {
            subObserver = ref[i];
            subObserver.handler(splices);
          }
        }
      }, {
        key: 'push',
        value: function push() {
          var returns, splice;
          splice = this.createSplice(this.arr.length, 0, arguments.length);
          returns = this.callOriginal('push', arguments);
          this.callHandlers([splice]);
          return returns;
        }
      }, {
        key: 'pop',
        value: function pop() {
          var returns, splice;
          if (this.arr.length === 0) {
            return;
          }
          splice = this.createSplice(this.arr.length - 1, 1, 0);
          returns = this.callOriginal('pop', arguments);
          this.callHandlers([splice]);
          return returns;
        }
      }, {
        key: 'unshift',
        value: function unshift() {
          for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }

          var returns, splice;
          splice = this.createSplice(0, 0, 1);
          returns = this.callOriginal('unshift', arguments);
          this.callHandlers([splice]);
          return returns;
        }
      }, {
        key: 'shift',
        value: function shift() {
          var returns, splice;
          if (this.arr.length === 0) {
            return;
          }
          splice = this.createSplice(0, 1, 0);
          returns = this.callOriginal('shift', arguments);
          this.callHandlers([splice]);
          return returns;
        }
      }, {
        key: 'splice',
        value: function splice() {
          var oldArr, returns, splices;
          oldArr = this.arr.slice();
          returns = this.callOriginal('splice', arguments);
          splices = ArrayCompare.calculateSplices(this.arr, oldArr);
          this.callHandlers(splices);
          return returns;
        }
      }, {
        key: 'reverse',
        value: function reverse() {
          var oldArr, returns, splices;
          oldArr = this.arr.slice();
          returns = this.callOriginal('reverse', arguments);
          splices = ArrayCompare.calculateSplices(this.arr, oldArr);
          this.callHandlers(splices);
          return returns;
        }
      }, {
        key: 'fill',
        value: function fill() {
          var oldArr, returns, splices;
          oldArr = this.arr.slice();
          returns = this.callOriginal('fill', arguments);
          splices = ArrayCompare.calculateSplices(this.arr, oldArr);
          this.callHandlers(splices);
          return returns;
        }
      }, {
        key: 'sort',
        value: function sort() {
          var oldArr, returns, splices;
          oldArr = this.arr.slice();
          returns = this.callOriginal('sort', arguments);
          splices = ArrayCompare.calculateSplices(this.arr, oldArr);
          this.callHandlers(splices);
          return returns;
        }
      }]);

      return DirectArrayObserver;
    }();

    ;

    observersMap = new Map();

    methodNames = "pop push reverse shift unshift splice fill sort".split(' ');

    return DirectArrayObserver;
  }();
}).call(undefined);