'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _expObserver = require('./exp-observer');

var _expObserver2 = _interopRequireDefault(_expObserver);

var _exp = require('./exp');

var _exp2 = _interopRequireDefault(_exp);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var DataBind;

module.exports = DataBind = function () {
  function DataBind(objL, expL, objR, expR, scope) {
    _classCallCheck(this, DataBind);

    var ref, val;
    this.onChangeL = this.onChangeL.bind(this);
    this.onChangeR = this.onChangeR.bind(this);
    this.objL = objL;
    this.expL = expL;
    this.objR = objR;
    this.expR = expR;
    this.scope = scope;
    this.destroyed = false;
    this.expL = new _exp2.default(this.expL);
    this.expR = new _exp2.default(this.expR);
    if (!this.expL.set) {
      throw new Error('DataBind invalid left-hand expression: ' + this.expL.code);
    }
    val = (ref = this.getR()) != null ? ref : this.getL();
    this.setL(val);
    this.setR(val);
    this.observerL = new _expObserver2.default(this.objL, this.expL, this.onChangeL);
    this.observerR = new _expObserver2.default(this.objR, this.expR, this.onChangeR, this.scope);
    return;
  }

  _createClass(DataBind, [{
    key: 'onChangeL',
    value: function onChangeL(val) {
      this.setR(val);
      if (this.isSync()) {
        return;
      }
      this.syncToL();
      if (this.notSync()) {
        throw Error('DataBind sync error: ' + this.expR.code + ' => ' + this.expL.code);
      }
    }
  }, {
    key: 'onChangeR',
    value: function onChangeR(val) {
      this.setL(val);
      if (this.isSync()) {
        return;
      }
      this.syncToR();
      if (this.notSync()) {
        throw Error('DataBind sync error: ' + this.expR.code + ' <= ' + this.expL.code);
      }
    }
  }, {
    key: 'syncToR',
    value: function syncToR() {
      this.setR(this.getL());
    }
  }, {
    key: 'syncToL',
    value: function syncToL() {
      this.setL(this.getR());
    }
  }, {
    key: 'getL',
    value: function getL() {
      return this.expL(this.objL);
    }
  }, {
    key: 'setL',
    value: function setL(val) {
      this.expL.set(this.objL, val);
    }
  }, {
    key: 'getR',
    value: function getR() {
      return this.expR(this.objR, this.scope);
    }
  }, {
    key: 'setR',
    value: function setR(val) {
      var base;
      if (typeof (base = this.expR).set === "function") {
        base.set(this.objR, val, this.scope);
      }
    }
  }, {
    key: 'isSync',
    value: function isSync() {
      var valL, valR;
      valL = this.getL();
      valR = this.getR();
      if (valL !== valL && valR !== valR) {
        return true;
      }
      return valL === valR;
    }
  }, {
    key: 'notSync',
    value: function notSync() {
      return !this.isSync();
    }
  }, {
    key: 'destroy',
    value: function destroy() {
      var ref, ref1;
      if (this.destroyed) {
        return;
      }
      if ((ref = this.observerL) != null) {
        ref.destroy();
      }
      if ((ref1 = this.observerR) != null) {
        ref1.destroy();
      }
      this.destroyed = true;
    }
  }]);

  return DataBind;
}();