'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

(function () {
  var Exp, ExpObserver, PathObserver, SubExpObserver, equals;

  PathObserver = require('./path-observer');

  Exp = require('./exp');

  equals = function equals(a, b) {
    if (a !== a && b !== b) {
      return true;
    }
    return a === b;
  };

  module.exports = ExpObserver = function () {
    function ExpObserver(context1, exp, handler) {
      var scope = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
      var init = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : false;

      _classCallCheck(this, ExpObserver);

      this.context = context1;
      this.exp = exp;
      this.handler = handler;
      this.scope = scope;
      this.exp = new Exp(this.exp);
      this.value = void 0;
      this.destroyed = false;
      this.subExps = this.getSubExps();
      this.subExpObservers = this.createSubExpObservers();
      if (init) {
        this.value = this.evalExp();
        this.handler(this.value);
      }
      return;
    }

    _createClass(ExpObserver, [{
      key: 'destroy',
      value: function destroy() {
        var i, len, ref, subExpObserver;
        if (this.destroyed) {
          return;
        }
        ref = this.subExpObservers;
        for (i = 0, len = ref.length; i < len; i++) {
          subExpObserver = ref[i];
          subExpObserver.destroy();
        }
        this.destroyed = true;
      }
    }, {
      key: 'getSubExps',
      value: function getSubExps() {
        return [this.exp];
      }
    }, {
      key: 'createSubExpObservers',
      value: function createSubExpObservers() {
        var _this = this;

        return this.subExps.map(function (subExp) {
          return _this.createSubExpObserver(subExp);
        });
      }
    }, {
      key: 'createSubExpObserver',
      value: function createSubExpObserver(subExp) {
        var _this2 = this;

        return new SubExpObserver(this.context, this.scope, subExp, function (value) {
          _this2.trigger();
        });
      }
    }, {
      key: 'evalExp',
      value: function evalExp() {
        return this.exp(this.context, this.scope);
      }
    }, {
      key: 'trigger',
      value: function trigger() {
        var newValue;
        newValue = this.evalExp();
        this.value = newValue;
        this.handler(this.value);
      }
    }]);

    return ExpObserver;
  }();

  SubExpObserver = function () {
    function SubExpObserver(context1, scope, exp, handler) {
      _classCallCheck(this, SubExpObserver);

      var i, len, path, ref;
      this.context = context1;
      this.scope = scope;
      this.exp = exp;
      this.handler = handler;
      this.exp = new Exp(this.exp);
      this.destroyed = false;
      this.observers = [];
      ref = this.exp.paths;
      for (i = 0, len = ref.length; i < len; i++) {
        path = ref[i];
        this.observers.push(this.createObserver(this.context, path));
        if (this.scope) {
          this.observers.push(this.createObserver(this.scope, path));
        }
      }
      return;
    }

    _createClass(SubExpObserver, [{
      key: 'evalExp',
      value: function evalExp() {
        return this.exp(this.context, this.scope);
      }
    }, {
      key: 'createObserver',
      value: function createObserver(context, path) {
        var _this3 = this;

        return new PathObserver(context, path, function () {
          var newValue;
          newValue = _this3.evalExp();
          if (!equals(newValue, _this3.value)) {
            _this3.value = newValue;
            _this3.handler(_this3.value);
          }
        });
      }
    }, {
      key: 'destroy',
      value: function destroy() {
        var i, len, observer, ref;
        if (this.destroyed) {
          return;
        }
        ref = this.observers;
        for (i = 0, len = ref.length; i < len; i++) {
          observer = ref[i];
          observer.destroy();
        }
        this.destroyed = true;
      }
    }]);

    return SubExpObserver;
  }();
}).call(undefined);