'use strict';

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _extendableBuiltin3(cls) {
  function ExtendableBuiltin() {
    var instance = Reflect.construct(cls, Array.from(arguments));
    Object.setPrototypeOf(instance, Object.getPrototypeOf(this));
    return instance;
  }

  ExtendableBuiltin.prototype = Object.create(cls.prototype, {
    constructor: {
      value: cls,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });

  if (Object.setPrototypeOf) {
    Object.setPrototypeOf(ExtendableBuiltin, cls);
  } else {
    ExtendableBuiltin.__proto__ = cls;
  }

  return ExtendableBuiltin;
}

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _extendableBuiltin(cls) {
  function ExtendableBuiltin() {
    var instance = Reflect.construct(cls, Array.from(arguments));
    Object.setPrototypeOf(instance, Object.getPrototypeOf(this));
    return instance;
  }

  ExtendableBuiltin.prototype = Object.create(cls.prototype, {
    constructor: {
      value: cls,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });

  if (Object.setPrototypeOf) {
    Object.setPrototypeOf(ExtendableBuiltin, cls);
  } else {
    ExtendableBuiltin.__proto__ = cls;
  }

  return ExtendableBuiltin;
}

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

(function () {
  var ALIASES, CONTEXT, Exp, HELPERS, KEYWORDS, ParseError, PathAccessor, PathStructure, PipeStructure, REF, SCOPE, Structure, Token, TokenList, VALUE, createExp, createGetterFunc, createSetterFunc, createStringExp;

  REF = '$$ref';

  VALUE = '$$val';

  SCOPE = '$$scope';

  CONTEXT = '$$context';

  HELPERS = '$$helpers';

  ALIASES = {
    'and': '&&',
    'or': '||',
    'then': '?',
    'else': ':',
    'is': '==',
    'isnt': '!=',
    'not': '!',
    'yes': 'true',
    'on': 'true',
    'no': 'false',
    'off': 'false',
    'undefined': 'void 0',
    'typeof': 'typeof ',
    'instanceof': 'instanceof ',
    '@': 'this',
    '#': 'scope'
  };

  KEYWORDS = {
    null: true,
    var: true,
    void: true,
    typeof: true,
    instanceof: true,
    undefined: true,
    true: true,
    false: true
  };

  module.exports = Exp = function () {
    var Exp = function () {
      function Exp(code) {
        _classCallCheck(this, Exp);

        var exp;
        if (!code) {
          throw Error('exp is empty');
        }
        if (typeof code === 'function') {
          return code;
        }
        if (Exp.cache[code]) {
          return Exp.cache[code];
        }
        if (Exp.test(code)) {
          exp = createStringExp(code);
        } else {
          exp = createExp(code);
        }
        Exp.cache[code] = exp;
        return exp;
      }

      _createClass(Exp, null, [{
        key: 'addPipe',
        value: function addPipe(name, pipe) {
          this.pipes[name] = pipe;
        }
      }, {
        key: 'pipe',
        value: function pipe(name) {
          var pipe;
          pipe = this.pipes[name];
          if (!pipe) {
            throw Error('Pipe \'' + name + '\' is not defined');
          }

          for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
            args[_key - 1] = arguments[_key];
          }

          return pipe.apply(undefined, args);
        }
      }, {
        key: 'test',
        value: function test(code) {
          return (/{{.*}}/.test(code)
          );
        }
      }, {
        key: 'parts',
        value: function parts(code) {
          return code.split(/{{|}}/);
        }
      }, {
        key: 'split',
        value: function split(code) {
          return this.parts(code).map(function (part, index) {
            if (index % 2) {
              return '{{' + part + '}}';
            } else {
              return part;
            }
          });
        }
      }, {
        key: 'getValue',
        value: function getValue(obj, exp) {
          exp = new Exp(exp);
          return exp(obj);
        }
      }, {
        key: 'setValue',
        value: function setValue(obj, exp, value) {
          exp = new Exp(exp);
          if (typeof exp.set === "function") {
            exp.set(obj, value);
          }
          return value;
        }
      }]);

      return Exp;
    }();

    ;

    Exp.cache = {};

    Exp.pipes = {};

    return Exp;
  }();

  createExp = function createExp(code) {
    var exp, getter, setter, tokens, unsafeGetter;
    tokens = new TokenList(code);
    getter = createGetterFunc(tokens.compile(false));
    setter = function () {
      try {
        return createSetterFunc(tokens.compile(true));
      } catch (error) {
        return null;
      }
    }();
    unsafeGetter = createGetterFunc(tokens.compile(false, false));
    exp = function exp(context, scope) {
      var safeMode = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;

      if (safeMode) {
        return getter(context, scope);
      } else {
        return unsafeGetter(context, scope);
      }
    };
    exp.isExp = true;
    exp.set = setter;
    exp.paths = tokens.getPaths();
    exp.isStatic = tokens.isStatic();
    exp.isStringExp = false;
    exp.code = code;
    return exp;
  };

  createStringExp = function createStringExp(code) {
    var compiledExpParts, compiledPart, exp, expParts, i, index, isStatic, len, part, partPaths, parts, paths, result, tokens;
    parts = Exp.parts(code);
    isStatic = true;
    paths = [];
    expParts = [];
    compiledExpParts = [];
    for (index = i = 0, len = parts.length; i < len; index = ++i) {
      part = parts[index];
      if (!part) {
        continue;
      }
      expParts.push(part);
      if (index % 2) {
        var _paths;

        tokens = new TokenList(part);
        partPaths = tokens.getPaths();
        (_paths = paths).push.apply(_paths, _toConsumableArray(partPaths));
        if (!tokens.isStatic()) {
          isStatic = false;
        }
        compiledPart = tokens.compile();
        compiledExpParts.push('( ' + REF + ' = (' + compiledPart + '), (' + REF + ' == null) || (' + REF + ' instanceof Promise) ? \'\' : String(' + REF + '))');
      } else {
        part = part.replace(/('|\r\n|\r|\n)/img, "\\$1");
        part = '\'' + part + '\'';
        compiledExpParts.push(part);
      }
    }
    result = compiledExpParts.join('+');
    exp = createGetterFunc(result);
    exp.set = null;
    exp.isStatic = isStatic;
    exp.isExp = true;
    exp.paths = paths;
    exp.isStringExp = true;
    exp.code = code;
    exp.expParts = expParts;
    return exp;
  };

  createGetterFunc = function createGetterFunc(code) {
    var args, body, getter;
    args = CONTEXT + ',' + SCOPE + ',' + HELPERS;
    body = 'var ' + REF + ';if(!' + SCOPE + ')' + SCOPE + '={};return ' + code;
    getter = new Function(args, body);
    return function (context, scope) {
      return getter(context, scope, Exp);
    };
  };

  createSetterFunc = function createSetterFunc(code) {
    var args, body, setter;
    try {
      args = CONTEXT + ',' + VALUE + ',' + SCOPE + ',' + HELPERS;
      body = 'var ' + REF + ';if(!' + SCOPE + ')' + SCOPE + '={};return ' + code + '=' + VALUE;
      setter = new Function(args, body);
      return function (context, value, scope) {
        return setter(context, value, scope, Exp);
      };
    } catch (error) {
      return null;
    }
  };

  ParseError = function (_extendableBuiltin2) {
    _inherits(ParseError, _extendableBuiltin2);

    function ParseError(message) {
      _classCallCheck(this, ParseError);

      var _this = _possibleConstructorReturn(this, (ParseError.__proto__ || Object.getPrototypeOf(ParseError)).call(this, message));

      _this.name = 'ParseError';
      return _possibleConstructorReturn(_this);
    }

    return ParseError;
  }(_extendableBuiltin(Error));

  Token = function () {
    var Token = function () {
      function Token(matches) {
        _classCallCheck(this, Token);

        this.value = matches[0];
        this.isString = !!matches[2];
        this.isKey = !!matches[3];
        this.isNumber = !!matches[4];
        this.isCrement = !!matches[6];
        this.isSymbol = matches[7];
        this.isWord = !!matches[5] || this.isKey;
        this.alias = ALIASES[this.value] || null;
        this.isLiteral = !!(this.isString || this.isNumber);
        this.isVar = this.value === REF || this.value === CONTEXT || this.value === VALUE;
        this.isKeyword = !!(KEYWORDS[this.value] || ALIASES[this.value]);
        this.isProp = !!(this.isWord && !this.isKeyword && !this.isKey && !this.isVar || this.value === '@' || this.value === '#');
        this.isOperator = !!(this.isSymbol || this.isCrement || this.isKeyword) && !this.isProp;
        this.isBracketStart = this.match('[', '(', '{');
        return;
      }

      _createClass(Token, [{
        key: 'match',
        value: function match() {
          var i, len, value;

          for (var _len2 = arguments.length, values = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
            values[_key2] = arguments[_key2];
          }

          for (i = 0, len = values.length; i < len; i++) {
            value = values[i];
            if (this.value === value) {
              return true;
            }
          }
          return false;
        }
      }, {
        key: 'toString',
        value: function toString() {
          return this.value;
        }
      }, {
        key: 'compile',
        value: function compile() {
          if (this.isString) {
            return this.value.replace(/\n/img, '\\n');
          }
          return this.alias || this.value;
        }
      }]);

      return Token;
    }();

    ;

    Token.regExp = /(("|')(?:\\\2|[\s\S])*?\2)|(?:([$\w]+)\s*:)|(\d+)|([$\w]+)|(\+\+|--)|(\S)/img;

    return Token;
  }();

  TokenList = function () {
    var TokenList = function (_extendableBuiltin4) {
      _inherits(TokenList, _extendableBuiltin4);

      function TokenList() {
        var code = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

        _classCallCheck(this, TokenList);

        if (typeof code === 'number') {
          var _this2 = _possibleConstructorReturn(this, (TokenList.__proto__ || Object.getPrototypeOf(TokenList)).call(this, code));

          _this2.code = '';
        } else {
          var _this2 = _possibleConstructorReturn(this, (TokenList.__proto__ || Object.getPrototypeOf(TokenList)).call(this));

          _this2.code = code;
        }
        if (TokenList.cache[_this2.code]) {
          var _ret;

          return _ret = TokenList.cache[_this2.code], _possibleConstructorReturn(_this2, _ret);
        }
        _this2.structures = null;
        if (_this2.code) {
          _this2.parseCode(_this2.code);
          TokenList.cache[_this2.code] = _this2;
        }
        return _possibleConstructorReturn(_this2);
      }

      _createClass(TokenList, [{
        key: 'getPaths',
        value: function getPaths() {
          var i, len, paths, ref, structure, structurePaths;
          paths = [];
          ref = this.getStructures();
          for (i = 0, len = ref.length; i < len; i++) {
            var _paths2;

            structure = ref[i];
            structurePaths = structure.getPaths();
            (_paths2 = paths).push.apply(_paths2, _toConsumableArray(structurePaths));
          }
          return paths;
        }
      }, {
        key: 'parseCode',
        value: function parseCode(code) {
          var _this3 = this;

          code.replace(Token.regExp, function () {
            for (var _len3 = arguments.length, args = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
              args[_key3] = arguments[_key3];
            }

            return _this3.push(new Token(args));
          });
        }
      }, {
        key: 'indexOfValue',
        value: function indexOfValue(value) {
          var index = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;

          var token;
          while (index < this.length) {
            token = this[index];
            if (token.value === value) {
              return index;
            }
            index++;
          }
          return -1;
        }
      }, {
        key: 'sequence',
        value: function sequence() {
          var index = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
          var handler = arguments[1];

          var setIndex, token;
          setIndex = function setIndex(newIndex) {
            if (newIndex < index) {
              throw ParseError('sequence setIndex set newIndex < index');
            }
            return index = newIndex;
          };
          while (index < this.length) {
            token = this[index];
            if (handler(token, index, setIndex) === false) {
              break;
            }
            index++;
          }
          return index;
        }
      }, {
        key: 'slice',
        value: function slice(start, end) {
          var tokens;
          tokens = _get(TokenList.prototype.__proto__ || Object.getPrototypeOf(TokenList.prototype), 'slice', this).call(this, start, end);
          tokens.code = tokens.toString();
          return tokens;
        }
      }, {
        key: 'prev',
        value: function prev(index) {
          return this[index - 1];
        }
      }, {
        key: 'next',
        value: function next(index) {
          return this[index + 1];
        }
      }, {
        key: 'findStringEnd',
        value: function findStringEnd(startToken, index) {
          var endIndex;
          endIndex = this.indexOfValue(startToken.value, index + 1);
          if (endIndex === -1) {
            throw new ParseError('string not closed in: ' + this.code);
          }
          return endIndex;
        }
      }, {
        key: 'findBracketEnd',
        value: function findBracketEnd(startToken, index) {
          var close, nesting, open, token;
          open = startToken.value;
          close = function () {
            switch (open) {
              case '[':
                return ']';
              case '(':
                return ')';
              case '{':
                return '}';
            }
          }();
          nesting = 0;
          while (index < this.length) {
            token = this[index];
            if (token.isQuote) {
              index = this.findStringEnd(token, index);
              token = this[index];
            }
            if (token.value === open) {
              nesting++;
            }
            if (token.value === close) {
              nesting--;
            }
            if (nesting === 0) {
              return index;
            }
            index++;
          }
          throw new ParseError('bracket not closed in: ' + this.code);
        }
      }, {
        key: 'findPathEnd',
        value: function findPathEnd(index) {
          var _this4 = this;

          return this.sequence(index, function (token, index, setIndex) {
            if (token.isProp) {
              return true;
            }
            if (token.value === '.') {
              return true;
            }
            if (token.match('(', '[')) {
              setIndex(_this4.findBracketEnd(token, index));
              return true;
            }
            return false;
          });
        }
      }, {
        key: 'findOtherEnd',
        value: function findOtherEnd(index) {
          return this.sequence(index, function (token) {
            if (token.isProp) {
              return false;
            }
            if (token.value === '|') {
              return false;
            }
          });
        }
      }, {
        key: 'findPipeEnd',
        value: function findPipeEnd(index) {
          var _this5 = this;

          return this.sequence(index + 1, function (token, index, setIndex) {
            var endIndex;
            if (token.isProp) {
              return;
            }
            if (token.value === '(') {
              endIndex = setIndex(_this5.findBracketEnd(token, index));
              setIndex(endIndex + 1);
            }
            return false;
          });
        }
      }, {
        key: 'getStructures',
        value: function getStructures() {
          var _this6 = this;

          var structures;
          if (this.structures) {
            return this.structures;
          }
          structures = [];
          this.sequence(0, function (token, index, setIndex) {
            var endIndex;
            if (token.isProp) {
              endIndex = _this6.findPathEnd(index);
              structures.push(new PathStructure(_this6.slice(index, endIndex)));
              setIndex(endIndex - 1);
              return;
            }
            if (token.value === '|') {
              endIndex = _this6.findPipeEnd(index);
              structures.push(new PipeStructure(_this6.slice(index + 1, endIndex)));
              setIndex(endIndex - 1);
              return;
            }
            endIndex = _this6.findOtherEnd(index);
            structures.push(new Structure(_this6.slice(index, endIndex)));
            setIndex(endIndex - 1);
          });
          this.structures = structures;
          return structures;
        }
      }, {
        key: 'toString',
        value: function toString() {
          var separator = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

          var values;
          values = this.map(function (token) {
            return token.toString();
          });
          return values.join(separator);
        }
      }, {
        key: 'compile',
        value: function compile() {
          var setterMode = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
          var safeMode = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

          var compiledCode, forceSetter, i, index, len, nextStructure, structure, structureCode, structures;
          structures = this.getStructures();
          compiledCode = '';
          if (setterMode) {
            if (structures.length !== 1) {
              throw Error('Cant compile setter');
            }
            if (structures[0].type !== 'path') {
              throw Error('Cant compile setter');
            }
          }
          for (index = i = 0, len = structures.length; i < len; index = ++i) {
            structure = structures[index];
            forceSetter = false;
            if (structure.type === 'pipe') {
              continue;
            }
            if (structure.type === 'path') {
              nextStructure = structures[index + 1];
              if (nextStructure) {
                forceSetter = nextStructure.tokens.some(function (token) {
                  return token.isCrement || token.value === '=';
                });
              }
            }
            structureCode = structure.compile(setterMode || forceSetter, safeMode);
            if (structure.type === 'path') {
              nextStructure = structures[index + 1];
              if (nextStructure instanceof PipeStructure) {
                structureCode = nextStructure.compile(structureCode);
              }
            }
            compiledCode += structureCode;
          }
          return compiledCode;
        }
      }, {
        key: 'isStatic',
        value: function isStatic() {
          var i, len, structure, structures;
          structures = this.getStructures();
          for (i = 0, len = structures.length; i < len; i++) {
            structure = structures[i];
            if (structure.type === 'path') {
              return false;
            }
            if (structure.type === 'pipe') {
              return false;
            }
          }
          return true;
        }
      }, {
        key: 'search',
        value: function search(value) {
          var i, index, len, ref, token;
          ref = this;
          for (index = i = 0, len = ref.length; i < len; index = ++i) {
            token = ref[index];
            if (token.value === value) {
              return index;
            }
          }
          return -1;
        }
      }]);

      return TokenList;
    }(_extendableBuiltin3(Array));

    ;

    TokenList.cache = {};

    return TokenList;
  }();

  Structure = function () {
    function Structure(tokens1) {
      var type = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'other';

      _classCallCheck(this, Structure);

      this.tokens = tokens1;
      this.type = type;
      return;
    }

    _createClass(Structure, [{
      key: 'toString',
      value: function toString() {
        return this.tokens.toString();
      }
    }, {
      key: 'compile',
      value: function compile() {
        var i, len, ref, string, token;
        string = '';
        ref = this.tokens;
        for (i = 0, len = ref.length; i < len; i++) {
          token = ref[i];
          string += token.compile();
        }
        return string;
      }
    }, {
      key: 'getPaths',
      value: function getPaths() {
        return [];
      }
    }]);

    return Structure;
  }();

  PipeStructure = function (_Structure) {
    _inherits(PipeStructure, _Structure);

    function PipeStructure(tokens) {
      _classCallCheck(this, PipeStructure);

      var _this7 = _possibleConstructorReturn(this, (PipeStructure.__proto__ || Object.getPrototypeOf(PipeStructure)).call(this, tokens, 'pipe'));

      _this7.name = '';
      _this7.args = null;
      _this7.parse(tokens);
      return _possibleConstructorReturn(_this7);
    }

    _createClass(PipeStructure, [{
      key: 'parse',
      value: function parse(tokens) {
        this.name = tokens[0].value;
        if (tokens.length > 1) {
          this.args = tokens.slice(2, -1);
        }
      }
    }, {
      key: 'getPaths',
      value: function getPaths() {
        var ref;
        return ((ref = this.args) != null ? ref.getPaths() : void 0) || [];
      }
    }, {
      key: 'compile',
      value: function compile(base) {
        if (this.args) {
          return HELPERS + '.pipe(\'' + this.name + '\',(' + base + '),' + this.args.compile() + ')';
        } else {
          return HELPERS + '.pipe(\'' + this.name + '\',(' + base + '))';
        }
      }
    }]);

    return PipeStructure;
  }(Structure);

  PathStructure = function (_Structure2) {
    _inherits(PathStructure, _Structure2);

    function PathStructure(tokens) {
      _classCallCheck(this, PathStructure);

      var _this8 = _possibleConstructorReturn(this, (PathStructure.__proto__ || Object.getPrototypeOf(PathStructure)).call(this, tokens, 'path'));

      _this8.accessors = _this8.parse(tokens);
      return _possibleConstructorReturn(_this8);
    }

    _createClass(PathStructure, [{
      key: 'getProps',
      value: function getProps() {
        var accessor, i, len, prop, props, ref;
        props = [];
        ref = this.accessors;
        for (i = 0, len = ref.length; i < len; i++) {
          accessor = ref[i];
          if (accessor.type === 'prop') {
            prop = accessor.name.toString();
            props.push(prop);
          }
        }
        return props;
      }
    }, {
      key: 'getPaths',
      value: function getPaths() {
        return [this.accessors.slice()];
      }
    }, {
      key: 'parse',
      value: function parse(tokens) {
        var accessors;
        accessors = [];
        tokens.sequence(0, function (token, index, setIndex) {
          var endIndex, exp, nextToken;
          if (token.isProp) {
            nextToken = tokens.next(index);
            if (!nextToken) {
              return accessors.push(new PathAccessor(token, 'prop'));
            } else {
              switch (nextToken.value) {
                case '.':
                  return accessors.push(new PathAccessor(token, 'prop'));
                case '(':
                  endIndex = tokens.findBracketEnd(nextToken, index + 1);
                  exp = tokens.slice(index + 2, endIndex);
                  accessors.push(new PathAccessor(token, 'call', exp));
                  return setIndex(endIndex);
                default:
                  return accessors.push(new PathAccessor(token, 'prop'));
              }
            }
          } else if (token.isOperator) {
            switch (token.value) {
              case '[':
                endIndex = tokens.findBracketEnd(token, index);
                exp = tokens.slice(index + 1, endIndex);
                accessors.push(new PathAccessor(null, 'exp', exp));
                return setIndex(endIndex);
              case '(':
                endIndex = tokens.findBracketEnd(token, index);
                exp = tokens.slice(index + 1, endIndex);
                accessors.push(new PathAccessor(null, 'call', exp));
                return setIndex(endIndex);
            }
          }
        });
        return accessors;
      }
    }, {
      key: 'compile',
      value: function compile() {
        var setterMode = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
        var safeMode = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

        var accessor, firstProp, i, index, len, path, ref;
        firstProp = this.accessors[0].name.compile();
        path = '(' + SCOPE + '.' + firstProp + '!=null?' + SCOPE + ':' + CONTEXT + ')';
        ref = this.accessors;
        for (index = i = 0, len = ref.length; i < len; index = ++i) {
          accessor = ref[index];
          if (safeMode) {
            if (setterMode && index === this.accessors.length - 1) {
              path = accessor.setterEscape(path);
              continue;
            }
            path = accessor.escape(path, safeMode);
          } else {
            path += accessor.compile();
          }
        }
        return path;
      }
    }]);

    return PathStructure;
  }(Structure);

  PathAccessor = function () {
    function PathAccessor(name1, type) {
      var exp1 = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;

      _classCallCheck(this, PathAccessor);

      this.name = name1;
      this.type = type;
      this.exp = exp1;
      return;
    }

    _createClass(PathAccessor, [{
      key: 'toString',
      value: function toString() {
        switch (this.type) {
          case 'prop':
            return '.' + this.name;
          case 'exp':
            return '[' + this.exp + ']';
          case 'call':
            if (this.name) {
              return '.' + this.name + '(' + this.exp + ')';
            } else {
              return '(' + this.exp + ')';
            }
        }
      }
    }, {
      key: 'compile',
      value: function compile() {
        switch (this.type) {
          case 'prop':
            return '.' + this.name.compile();
          case 'exp':
            return '[' + this.exp.compile() + ']';
          case 'call':
            if (this.name) {
              return '.' + this.name.compile() + '(' + this.exp.compile() + ')';
            } else {
              return '(' + this.exp.compile() + ')';
            }
        }
      }
    }, {
      key: 'escape',
      value: function escape(base) {
        var exp;
        switch (this.type) {
          case 'prop':
            return '(' + REF + '=' + base + ',' + REF + '!=null?' + REF + '.' + this.name.compile() + ':void 0)';
          case 'exp':
            return '(' + REF + '=' + base + ',' + REF + '!=null?' + REF + '[' + this.exp.compile() + ']:void 0)';
          case 'call':
            exp = this.exp.compile();
            if (this.name) {
              return '(' + REF + '=' + base + ',' + REF + '!=null&&typeof ' + REF + '.' + this.name.compile() + '===\'function\'?' + REF + '.' + this.name.compile() + '(' + exp + '):void 0)';
            } else {
              return '(' + REF + '=' + base + ',typeof ' + REF + '===\'function\'?' + REF + '(' + exp + '):void 0)';
            }
        }
      }
    }, {
      key: 'setterEscape',
      value: function setterEscape(base) {
        return '(' + base + ' || {})' + this.toString();
      }
    }]);

    return PathAccessor;
  }();
}).call(undefined);