'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _propObserver = require('./prop-observer');

var _propObserver2 = _interopRequireDefault(_propObserver);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var CallAccessorObserver, ExpAccessorObserver, PathAccessorObserver, PathObserver;

module.exports = PathObserver = function () {
  function PathObserver(pathContext, path, handler, globalContext) {
    var _this = this;

    _classCallCheck(this, PathObserver);

    this.pathContext = pathContext;
    this.path = path;
    this.handler = handler;
    if (globalContext == null) {
      this.globalContext = this.pathContext;
    }
    this.path = this.path.slice();
    this.accessor = this.path.pop();
    this.accessorObserver = null;
    this.accessorContext = null;
    this.lastValue = void 0;
    if (!this.path.length) {
      this.accessorContext = this.pathContext;
    } else {
      this.subPathObserver = new PathObserver(this.pathContext, this.path, function (value) {
        _this.accessorContext = value;
        return _this.updateAccessorObserver();
      });
    }
    this.updateAccessorObserver();
    return;
  }

  _createClass(PathObserver, [{
    key: 'destroy',
    value: function destroy() {
      var ref, ref1;
      if ((ref = this.subPathObserver) != null) {
        ref.destroy();
      }
      if ((ref1 = this.accessorObserver) != null) {
        ref1.destroy();
      }
    }
  }, {
    key: 'updateAccessorObserver',
    value: function updateAccessorObserver() {
      var _this2 = this;

      var AccessorObserver, ref;
      if ((ref = this.accessorObserver) != null) {
        ref.destroy();
      }
      if (Object(this.accessorContext) !== this.accessorContext) {
        this.callHandler(this.accessorContext);
        return;
      }
      AccessorObserver = function () {
        switch (this.accessor.type) {
          case 'prop':
            return PathAccessorObserver;
          case 'call':
            return CallAccessorObserver;
          case 'exp':
            return ExpAccessorObserver;
        }
      }.call(this);
      this.accessorObserver = new AccessorObserver(this.accessorContext, this.accessor, function (value) {
        return _this2.callHandler(value);
      }, this.globalContext);
    }
  }, {
    key: 'callHandler',
    value: function callHandler(value) {
      this.handler(value, this.lastValue);
      this.lastValue = this.value;
    }
  }]);

  return PathObserver;
}();

PathAccessorObserver = function () {
  function PathAccessorObserver(context, accessor, handler) {
    var _this3 = this;

    _classCallCheck(this, PathAccessorObserver);

    this.context = context;
    this.accessor = accessor;
    this.handler = handler;
    this.prop = this.accessor.name.toString();
    this.observer = new _propObserver2.default(this.context, this.prop, function (value) {
      _this3.handler(value);
    });
    this.handler(this.context[this.prop]);
    return;
  }

  _createClass(PathAccessorObserver, [{
    key: 'destroy',
    value: function destroy() {
      this.observer.destroy();
    }
  }]);

  return PathAccessorObserver;
}();

ExpAccessorObserver = function () {
  function ExpAccessorObserver(context, accessor, handler, globalContext1) {
    var _this4 = this;

    _classCallCheck(this, ExpAccessorObserver);

    var Exp, ExpObserver;
    this.context = context;
    this.accessor = accessor;
    this.handler = handler;
    this.globalContext = globalContext1;
    ExpObserver = require('./exp-observer');
    Exp = require('./exp');
    this.exp = new Exp(this.accessor.exp.toString());
    this.prop = this.exp(this.globalContext);
    this.expObserver = new ExpObserver(this.globalContext, this.exp, function (prop) {
      _this4.prop = prop;
      _this4.updatePropObserver();
    });
    this.updatePropObserver();
    return;
  }

  _createClass(ExpAccessorObserver, [{
    key: 'updatePropObserver',
    value: function updatePropObserver() {
      var _this5 = this;

      var ref;
      if ((ref = this.propObserver) != null) {
        ref.destroy();
      }
      this.propObserver = new _propObserver2.default(this.context, this.prop, function (value) {
        return _this5.handler(value);
      });
      this.handler(this.context[this.prop]);
    }
  }, {
    key: 'destroy',
    value: function destroy() {
      var ref;
      this.expObserver.destroy();
      if ((ref = this.propObserver) != null) {
        ref.destroy();
      }
    }
  }]);

  return ExpAccessorObserver;
}();

CallAccessorObserver = function CallAccessorObserver(context, accessor, handler, globalContext1) {
  _classCallCheck(this, CallAccessorObserver);

  this.context = context;
  this.accessor = accessor;
  this.handler = handler;
  this.globalContext = globalContext1;
  throw 'TODO CallAccessorObserver';
  return;
};