'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

(function () {
  var DirectPropObserver, Map, PropObserver;

  Map = require('../polyfill/map');

  module.exports = PropObserver = function () {
    function PropObserver(target1, prop1, handler1) {
      _classCallCheck(this, PropObserver);

      this.target = target1;
      this.prop = prop1;
      this.handler = handler1;
      this.arrayMode = this.target instanceof Array && this.prop === 'length';
      if (this.arrayMode) {
        this.arrayObserver = this.initArrayObserver();
      } else {
        this.directObserver = this.initDirectObserver();
      }
      return;
    }

    _createClass(PropObserver, [{
      key: 'destroy',
      value: function destroy() {
        if (this.arrayMode) {
          this.arrayObserver.destroy();
        } else {
          this.directObserver.removeSubObserver(this);
        }
      }
    }, {
      key: 'initDirectObserver',
      value: function initDirectObserver() {
        var directObserver;
        directObserver = new DirectPropObserver(this.target, this.prop);
        directObserver.addSubObserver(this);
        return directObserver;
      }
    }, {
      key: 'initArrayObserver',
      value: function initArrayObserver() {
        var _this = this;

        var ArrayObserver, arrayObserver, length;
        length = this.target.length;
        ArrayObserver = require('./array-observer');
        arrayObserver = new ArrayObserver(this.target, function () {
          var oldLength;
          oldLength = length;
          length = _this.target.length;
          if (length !== oldLength) {
            _this.handler(length, oldLength);
          }
        });
        return arrayObserver;
      }
    }]);

    return PropObserver;
  }();

  DirectPropObserver = function () {
    var observersMap;

    var DirectPropObserver = function () {
      function DirectPropObserver(target, prop1) {
        _classCallCheck(this, DirectPropObserver);

        this.callHandlers = this.callHandlers.bind(this);
        this.prop = prop1;
        this.context = this.getContext(target, this.prop);
        if (this.hasObserver()) {
          return this.getObserver();
        }
        this.descriptor = this.getDescriptor();
        this.setterMode = !!this.descriptor.set;
        if (!this.descriptor.configurable) {
          throw new Error("Не могу повесить обсервер, свойство not configurable");
        }
        this.subObservers = [];
        this.changetTargets = [this.context];
        this.privateProp = this.prop + '$';
        this.saveOriginalValue();
        this.saveObserver();
        return;
      }

      _createClass(DirectPropObserver, [{
        key: 'destroy',
        value: function destroy() {
          this.disableTrap();
          this.cleanTargets();
          this.removeObserver();
        }
      }, {
        key: 'saveOriginalValue',
        value: function saveOriginalValue() {
          if (this.setterMode) {
            Object.defineProperty(this.context, this.privateProp, {
              enumerable: false,
              configurable: true,
              set: this.descriptor.set,
              get: this.descriptor.get
            });
          } else {
            Object.defineProperty(this.context, this.privateProp, {
              writable: true,
              enumerable: false,
              configurable: true,
              value: this.context[this.prop]
            });
          }
        }
      }, {
        key: 'addSubObserver',
        value: function addSubObserver(subObserver) {
          this.subObservers.push(subObserver);
          if (this.subObservers.length === 1) {
            this.enableTrap();
          }
        }
      }, {
        key: 'removeSubObserver',
        value: function removeSubObserver(subObserver) {
          var index;
          index = this.subObservers.indexOf(subObserver);
          if (index === -1) {
            return;
          }
          this.subObservers.splice(index, 1);
          if (this.subObservers.length === 0) {
            this.destroy();
          }
        }
      }, {
        key: 'getHandlers',
        value: function getHandlers(target) {
          var self;
          self = this;
          return this.subObservers.filter(function (subObserver) {
            return self.canChange(target, subObserver.target);
          }).map(function (subObserver) {
            return subObserver.handler;
          });
        }
      }, {
        key: 'canChange',
        value: function canChange(changedObj, target) {
          while (target) {
            if (target === changedObj) {
              return true;
            }
            if (this.hasOwnProperty(target, this.prop)) {
              return false;
            }
            if (this.hasOwnProperty(target, this.privateProp)) {
              return false;
            }
            target = Object.getPrototypeOf(target);
          }
          return false;
        }
      }, {
        key: 'mustBeCap',
        value: function mustBeCap(target) {}
      }, {
        key: 'hasSubObserver',
        value: function hasSubObserver(target) {
          return this.subObservers.some(function (subObserver) {
            return subObserver.target === target;
          });
        }
      }, {
        key: 'getDescriptor',
        value: function getDescriptor() {
          var descriptor;
          descriptor = Object.getOwnPropertyDescriptor(this.context, this.prop);
          if (descriptor) {
            return descriptor;
          }
          return {
            writable: true,
            enumerable: true,
            configurable: true,
            value: void 0
          };
        }
      }, {
        key: 'enableTrap',
        value: function enableTrap() {
          var self;
          self = this;
          Object.defineProperty(this.context, this.prop, {
            enumerable: this.descriptor.enumerable,
            configurable: true,
            get: function get() {
              return self.getValue(this);
            },
            set: function set(value) {
              return self.setValue(this, value);
            }
          });
        }
      }, {
        key: 'disableTrap',
        value: function disableTrap() {
          Object.defineProperty(this.context, this.prop, {
            value: this.context[this.privateProp],
            configurable: true,
            enumerable: true,
            writable: true
          });
        }
      }, {
        key: 'cleanTargets',
        value: function cleanTargets() {
          var i, len, ref, target;
          ref = this.changetTargets;
          for (i = 0, len = ref.length; i < len; i++) {
            target = ref[i];
            if (this.setterMode) {
              if (target === this.context) {
                Object.defineProperty(target, this.prop, this.descriptor);
              }
            } else {
              Object.defineProperty(target, this.prop, {
                value: target[this.privateProp],
                enumerable: this.descriptor.enumerable,
                configurable: true,
                writable: true
              });
            }
            delete target[this.privateProp];
          }
        }
      }, {
        key: 'getContext',
        value: function getContext(target, prop) {
          var context, proto;
          context = target;
          while (true) {
            if (this.hasOwnProperty(context, prop)) {
              break;
            }
            proto = Object.getPrototypeOf(context);
            if (proto === null) {
              break;
            }
            if (proto === Object.prototype) {
              break;
            }
            context = proto;
          }
          return context;
        }
      }, {
        key: 'saveObserver',
        value: function saveObserver() {
          var storage;
          if (!observersMap.has(this.context)) {
            observersMap.set(this.context, {});
          }
          storage = observersMap.get(this.context);
          storage[this.prop] = this;
        }
      }, {
        key: 'getObserver',
        value: function getObserver() {
          var storage;
          if (!observersMap.has(this.context)) {
            return;
          }
          storage = observersMap.get(this.context);
          return storage[this.prop];
        }
      }, {
        key: 'removeObserver',
        value: function removeObserver() {
          var storage;
          if (!observersMap.has(this.context)) {
            return;
          }
          storage = observersMap.get(this.context);
          delete storage[this.prop];
          if (Object.keys(storage).length === 0) {
            observersMap.delete(this.context);
          }
        }
      }, {
        key: 'hasObserver',
        value: function hasObserver() {
          return !!this.getObserver();
        }
      }, {
        key: 'getValue',
        value: function getValue(target) {
          return target[this.privateProp];
        }
      }, {
        key: 'setValue',
        value: function setValue(target, value) {
          var oldValue;
          oldValue = target[this.privateProp];
          target[this.privateProp] = value;
          if (this.equals(oldValue, value)) {
            return;
          }
          if (this.changetTargets.indexOf(target) === -1) {
            this.changetTargets.push(target);
          }
          this.callHandlers(target, value, oldValue);
        }
      }, {
        key: 'equals',
        value: function equals(val1, val2) {
          if (val1 !== val1 && val2 !== val2) {
            return true;
          }
          return val1 === val2;
        }
      }, {
        key: 'callHandlers',
        value: function callHandlers(target, value, oldValue) {
          var handler, i, index, len, ref;
          ref = this.getHandlers(target);
          for (index = i = 0, len = ref.length; i < len; index = ++i) {
            handler = ref[index];
            handler.call(target, value, oldValue);
          }
        }
      }, {
        key: 'hasOwnProperty',
        value: function hasOwnProperty(obj, prop) {
          return Object.prototype.hasOwnProperty.call(obj, prop);
        }
      }]);

      return DirectPropObserver;
    }();

    ;

    observersMap = new Map();

    return DirectPropObserver;
  }();
}).call(undefined);