'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

(function () {
  var Draggable;

  module.exports = Draggable = function () {
    var Draggable = function () {
      function Draggable(node) {
        _classCallCheck(this, Draggable);

        this.onMouseDown = this.onMouseDown.bind(this);
        this.onMouseUp = this.onMouseUp.bind(this);
        this.onMouseMove = this.onMouseMove.bind(this);
        this.node = node;
        this.startX = 0;
        this.startY = 0;
        this.lastX = 0;
        this.lastY = 0;
        this.state = false;
        this.initHandlers();
        return;
      }

      _createClass(Draggable, [{
        key: 'initHandlers',
        value: function initHandlers() {
          this.node.on('mousedown', this.onMouseDown);
          ui.dom.on('mouseup', this.onMouseUp);
          ui.dom.on('mousemove', this.onMouseMove);
        }
      }, {
        key: 'onMouseDown',
        value: function onMouseDown(event) {
          this.state = true;
          this.startX = event.clientX;
          this.startY = event.clientY;
          this.lastX = 0;
          this.lastY = 0;
          this.node.emit('drag-start');
          event.prevent();
        }
      }, {
        key: 'onMouseUp',
        value: function onMouseUp(event) {
          this.state = false;
          this.node.emit('drag-end');
          this.node.emit('drag-stop');
        }
      }, {
        key: 'onMouseMove',
        value: function onMouseMove(event) {
          var moveX, moveY, x, y;
          if (!this.state) {
            return;
          }
          x = event.clientX - this.startX;
          y = event.clientY - this.startY;
          moveX = x - this.lastX;
          moveY = y - this.lastY;
          this.lastX = x;
          this.lastY = y;
          this.node.emit('drag', { x: x, y: y, moveX: moveX, moveY: moveY });
        }
      }]);

      return Draggable;
    }();

    ;

    Draggable.attribute = 'draggable';

    return Draggable;
  }();
}).call(undefined);