'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

(function () {
  var DOM, For, Iteration;

  DOM = require('../dom');

  module.exports = For = function () {
    var regExp;

    var For = function () {
      _createClass(For, null, [{
        key: 'compile',
        value: function compile(template, tree) {
          var comment, exp, indexName, itemName, match, subTree;
          exp = template.attr('*for');
          template.removeAttr('*for');
          comment = DOM.createComment(' *for ' + exp + ' ');
          tree.replace(comment);
          match = exp.match(regExp);
          itemName = match[1];
          indexName = match[2];
          exp = match[3];
          subTree = tree.create(template);
          return [subTree, itemName, indexName, exp];
        }
      }]);

      function For(label1, component, scope1, subThree, itemName1, indexName1, exp) {
        _classCallCheck(this, For);

        this.changeArray = this.changeArray.bind(this);
        this.renderSplices = this.renderSplices.bind(this);
        this.label = label1;
        this.component = component;
        this.scope = scope1;
        this.subThree = subThree;
        this.itemName = itemName1;
        this.indexName = indexName1;
        this.array = [];
        this.iterations = [];
        this.arrayObserver = null;
        this.propWatcher = ui.watch(this.component, exp, this.changeArray, this.scope);
        return;
      }

      _createClass(For, [{
        key: 'destructor',
        value: function destructor() {
          var ref;
          this.propWatcher.destroy();
          if ((ref = this.arrayObserver) != null) {
            ref.destroy();
          }
        }
      }, {
        key: 'changeArray',
        value: function changeArray(newArray) {
          var i, j, ref, results, results1, splices;
          if (newArray == null) {
            newArray = [];
          }
          if (typeof newArray === 'number') {
            if (newArray <= 0) {
              newArray = [];
            } else {
              newArray = function () {
                results = [];
                for (var i = 0; 0 <= newArray ? i < newArray : i > newArray; 0 <= newArray ? i++ : i--) {
                  results.push(i);
                }
                return results;
              }.apply(this);
            }
          } else if (typeof newArray === 'string' && !isNaN(newArray)) {
            newArray = +newArray;
            newArray = function () {
              results1 = [];
              for (var j = 0; 0 <= newArray ? j < newArray : j > newArray; 0 <= newArray ? j++ : j--) {
                results1.push(j);
              }
              return results1;
            }.apply(this);
          } else if (!(newArray instanceof Array)) {
            throw Error('*for directive should take a number or array');
          }
          splices = ui.diff(newArray, this.array);
          this.array = newArray;
          if ((ref = this.arrayObserver) != null) {
            ref.destroy();
          }
          this.arrayObserver = ui.watchArray(this.array, this.renderSplices);
          if (splices.length) {
            this.renderSplices(splices);
          }
        }
      }, {
        key: 'renderSplices',
        value: function renderSplices(splices) {
          var i, len, splice;
          for (i = 0, len = splices.length; i < len; i++) {
            splice = splices[i];
            this.renderSplice(splice);
          }
          this.updateIndexes();
        }
      }, {
        key: 'renderSplice',
        value: function renderSplice(splice) {
          var _iterations;

          var addedCnt, cnt, content, i, iteration, j, len, len1, newIterations, removed, removedCnt, startIndex;
          startIndex = splice.index;
          addedCnt = splice.addedCount;
          removedCnt = splice.removed.length;
          newIterations = [];
          content = [];
          cnt = 0;
          while (cnt < addedCnt) {
            iteration = new Iteration(this.subThree, this.component, this.scope);
            iteration.set(this.itemName, this.array[startIndex + cnt]);
            newIterations.push(iteration);
            content.push(iteration.node);
            content.push(iteration.endLabel);
            cnt++;
          }
          this.insertIterationsContent(startIndex, content);
          removed = (_iterations = this.iterations).splice.apply(_iterations, [startIndex, removedCnt].concat(_toConsumableArray(newIterations)));
          for (i = 0, len = removed.length; i < len; i++) {
            iteration = removed[i];
            iteration.destroy();
          }
          for (j = 0, len1 = newIterations.length; j < len1; j++) {
            iteration = newIterations[j];
            iteration.init();
          }
        }
      }, {
        key: 'insertIterationsContent',
        value: function insertIterationsContent(index, content) {
          var label;
          if (index === 0) {
            label = this.label;
          } else if (index > this.iterations.length - 1) {
            label = this.iterations[this.iterations.length - 1].endLabel;
          } else {
            label = this.iterations[index].endLabel;
          }
          label.after(content);
        }
      }, {
        key: 'updateIndexes',
        value: function updateIndexes() {
          var i, index, iteration, len, ref;
          if (!this.indexName) {
            return;
          }
          ref = this.iterations;
          for (index = i = 0, len = ref.length; i < len; index = ++i) {
            iteration = ref[index];
            iteration.set(this.indexName, index);
          }
        }
      }]);

      return For;
    }();

    ;

    regExp = /^\s*(?:([\w$]+)(?:,\s*([\w$]+))?\s+in\s+)?(.+?)\s*$/;

    For.attribute = 'for';

    For.priority = 1000;

    For.terminal = true;

    return For;
  }();

  Iteration = function () {
    function Iteration(subThree, component, scope) {
      _classCallCheck(this, Iteration);

      this.set = this.set.bind(this);
      this.subThree = subThree;
      this.component = component;
      this.scope = Object.create(scope);
      this.node = this.subThree.template.clone();
      this.endLabel = DOM.createComment(' *for iteration ');
      return;
    }

    _createClass(Iteration, [{
      key: 'set',
      value: function set(key, value) {
        this.scope[key] = value;
      }
    }, {
      key: 'init',
      value: function init(item) {
        this.subThree.init(this.node, this.component, this.scope);
      }
    }, {
      key: 'destroy',
      value: function destroy() {
        this.endLabel.remove(true);
        this.node.remove(true);
      }
    }]);

    return Iteration;
  }();
}).call(undefined);