'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

(function () {
  var HtmlParser,
      indexOf = [].indexOf;

  module.exports = HtmlParser = function () {
    var SINGLE_TAGS, TAG, TEXT, attrsRegExp, dotClassRegExp, tagRegExp;

    var HtmlParser = function () {
      function HtmlParser() {
        _classCallCheck(this, HtmlParser);

        this.DOM = require('../index');
        return;
      }

      _createClass(HtmlParser, [{
        key: 'parse',
        value: function parse(html) {
          var context, i, index, j, len, len1, node, nodes, token, tokens, type, value;
          html = html + '';
          context = this.DOM.createElement('tmp');
          tokens = this.getTokens(html);
          for (index = i = 0, len = tokens.length; i < len; index = ++i) {
            token = tokens[index];
            value = token.value;
            type = token.type;
            switch (type) {
              case TEXT:
                context.append(this.DOM.createText(value));
                break;
              case TAG:
                if (token.open) {
                  node = this.DOM.createElement(value, token.attrs);
                  context.append(node);
                  if (indexOf.call(SINGLE_TAGS, value) < 0) {
                    context = node;
                  }
                } else {
                  if (indexOf.call(SINGLE_TAGS, value) < 0) {
                    context = context.parent;
                  }
                }
            }
          }
          nodes = context.children.slice();
          for (j = 0, len1 = nodes.length; j < len1; j++) {
            node = nodes[j];
            node.remove();
          }
          return nodes;
        }
      }, {
        key: 'getTokens',
        value: function getTokens(html) {
          var _this = this;

          var prevEndIndex, tokens;
          prevEndIndex = 0;
          tokens = [];
          html.replace(tagRegExp, function (match, openTag, attrs, quote, closeTag, index) {
            if (index > prevEndIndex) {
              tokens.push({
                type: TEXT,
                value: html.slice(prevEndIndex, index)
              });
            }
            if (openTag) {
              tokens.push({
                type: TAG,
                open: true,
                value: openTag,
                attrs: _this.parseAttrs(attrs)
              });
            } else if (closeTag) {
              tokens.push({
                type: TAG,
                open: false,
                value: closeTag
              });
            }
            prevEndIndex = index + match.length;
          });
          if (html.length > prevEndIndex) {
            tokens.push({
              type: TEXT,
              value: html.slice(prevEndIndex, html.length)
            });
          }
          return tokens;
        }
      }, {
        key: 'parseAttrs',
        value: function parseAttrs(attrs) {
          var attrsObj, dotClasses, dotClassesStr;
          attrsObj = {};
          dotClasses = [];
          if (attrs != null) {
            attrs.replace(attrsRegExp, function (match, name, quote, value, value2, name2) {
              var dotClassName, ref;
              value = (ref = value != null ? value : value2) != null ? ref : '';
              name = name != null ? name : name2;
              if (dotClassRegExp.test(name) && !value) {
                dotClassName = name.match(dotClassRegExp)[1];
                dotClasses.push(dotClassName);
                return;
              }
              attrsObj[name] = value;
            });
          }
          if (dotClasses.length) {
            dotClassesStr = dotClasses.join(' ');
            if (attrsObj['class']) {
              attrsObj['class'] += ' ' + dotClassesStr;
            } else {
              attrsObj['class'] = dotClassesStr;
            }
          }
          return attrsObj;
        }
      }]);

      return HtmlParser;
    }();

    ;

    tagRegExp = /<([\w-]+)\s*((?:[^>]+=("|').*?\3|[^>]+)\s*)*>|<\/([\w-]+)>/img;

    attrsRegExp = /(\S+?)\s*=\s*(?:(?:("|')(.*?)\2)|(\S+))|(\S+)/img;

    dotClassRegExp = /^\.(.+)/;

    TAG = 0;

    TEXT = 1;

    SINGLE_TAGS = 'area base basefont bgsound br col command embed hr img input isindex keygen link meta param source track wbr'.split(/\s+/);

    return HtmlParser;
  }();
}).call(undefined);