'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

(function () {
  var Selector,
      indexOf = [].indexOf;

  module.exports = Selector = function () {
    var cache, regExp, subSelectorRegExp;

    var Selector = function () {
      function Selector(selectorText) {
        _classCallCheck(this, Selector);

        if (cache[selectorText]) {
          return cache[selectorText];
        }
        this.selectors = this.parseSelector(selectorText);
        cache[selectorText] = this;
        return;
      }

      _createClass(Selector, [{
        key: 'parseSelector',
        value: function parseSelector(selector) {
          var _this = this;

          var i, len, part, ref, selectors, subSelectors;
          selectors = [];
          ref = selector.trim().split(/\s*,\s*/);
          for (i = 0, len = ref.length; i < len; i++) {
            part = ref[i];
            subSelectors = [];
            part.replace(regExp, function (match, own, subSelector) {
              return subSelectors.push({
                own: !!own,
                selector: _this.parseSubSelector(subSelector)
              });
            });
            selectors.push(subSelectors);
          }
          return selectors;
        }
      }, {
        key: 'parseSubSelector',
        value: function parseSubSelector(subSelector) {
          var parsed;
          parsed = {
            tag: null,
            attrs: []
          };
          subSelector.replace(subSelectorRegExp, function (match, tag, className, id, attrName, attrMode, quote, attrValue) {
            var mode;
            if (tag === '*') {
              tag = null;
            }
            if (tag) {
              parsed.tag = tag;
            }
            if (className) {
              parsed.attrs.push({
                name: 'class',
                value: className,
                mode: 'word'
              });
            } else if (id) {
              parsed.attrs.push({
                name: 'id',
                value: id,
                mode: 'equals'
              });
            } else if (attrName) {
              if (attrValue != null) {
                mode = function () {
                  switch (attrMode) {
                    case '^':
                      return 'start';
                    case '$':
                      return 'end';
                    case '*':
                      return 'content';
                    case '~':
                      return 'word';
                    case '|':
                      return 'dash';
                    default:
                      return 'equals';
                  }
                }();
              }
              parsed.attrs.push({
                name: attrName,
                value: attrValue,
                mode: mode
              });
            }
          });
          return parsed;
        }
      }, {
        key: 'select',
        value: function select(element) {
          var contextElement, contextElements, found, foundElements, i, j, k, l, len, len1, len2, len3, newContextElements, own, ref, selector, subSelector, subSelectors;
          found = [];
          ref = this.selectors;
          for (i = 0, len = ref.length; i < len; i++) {
            subSelectors = ref[i];
            if (!subSelectors.length) {
              continue;
            }
            contextElements = [element];
            for (j = 0, len1 = subSelectors.length; j < len1; j++) {
              subSelector = subSelectors[j];
              newContextElements = [];
              for (k = 0, len2 = contextElements.length; k < len2; k++) {
                var _newContextElements;

                contextElement = contextElements[k];
                own = subSelector.own;
                selector = subSelector.selector;
                foundElements = this.selectChildren(contextElement, selector, own);
                (_newContextElements = newContextElements).push.apply(_newContextElements, _toConsumableArray(foundElements));
              }
              contextElements = newContextElements;
              if (!contextElements.length) {
                break;
              }
            }
            for (l = 0, len3 = contextElements.length; l < len3; l++) {
              contextElement = contextElements[l];
              if (found.indexOf(contextElement) === -1) {
                found.push(contextElement);
              }
            }
          }
          return found;
        }
      }, {
        key: 'selectChildren',
        value: function selectChildren(element, subSelector) {
          var own = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

          var child, children, elements, i, len, subChildren;
          elements = [];
          children = element.children;
          if (children) {
            for (i = 0, len = children.length; i < len; i++) {
              child = children[i];
              if (this.matchElement(child, subSelector)) {
                elements.push(child);
              }
              if (!own) {
                var _elements;

                subChildren = this.selectChildren(child, subSelector);
                (_elements = elements).push.apply(_elements, _toConsumableArray(subChildren));
              }
            }
          }
          return elements;
        }
      }, {
        key: 'matchElement',
        value: function matchElement(element, subSelector) {
          var attr, attrValue, i, index, len, name, ref, value, words;
          if (element.nodeType !== 'element') {
            return false;
          }
          if (subSelector.tag && element.tag !== subSelector.tag) {
            return false;
          }
          ref = subSelector.attrs;
          for (i = 0, len = ref.length; i < len; i++) {
            attr = ref[i];
            name = attr.name;
            if (!element.hasAttr(name)) {
              return false;
            }
            value = '' + attr.value;
            attrValue = '' + element.attrs.get(name);
            switch (attr.mode) {
              case 'equals':
                if (value !== attrValue) {
                  return false;
                }
                break;
              case 'start':
                if (attrValue.indexOf(value) !== 0) {
                  return false;
                }
                break;
              case 'end':
                index = attrValue.lastIndexOf(value);
                if (index === -1) {
                  return false;
                }
                if (index + value.length !== attrValue.length) {
                  return false;
                }
                break;
              case 'content':
                index = attrValue.indexOf(value);
                if (index === -1) {
                  return false;
                }
                break;
              case 'word':
                words = attrValue.split(/\s+/img);
                if (indexOf.call(words, value) < 0) {
                  return false;
                }
                break;
              case 'dash':
                words = attrValue.split(/-/img);
                if (words[0] !== value) {
                  return false;
                }
            }
          }
          return true;
        }
      }]);

      return Selector;
    }();

    ;

    regExp = /(?:(\s*>\s*)|^|\s+)(\S+)/img;

    subSelectorRegExp = /([\w-]+)|\.([\w-]+)|#([\w-]+)|\[([\w-]+)(?:(\^|\$|\*|~|\|)?=('|")(.*?)\6)?]/img;

    cache = {};

    return Selector;
  }();
}).call(undefined);