'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

(function () {
  var EventEmitter,
      Style,
      allCssProps,
      dashedProps,
      boundMethodCheck = function boundMethodCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new Error('Bound instance method accessed before binding');
    }
  };

  EventEmitter = require('../../core/event-emitter');

  allCssProps = 'alignContent alignItems alignSelf alignmentBaseline all animation animationDelay animationDirection animationDuration animationFillMode animationIterationCount animationName animationPlayState animationTimingFunction backfaceVisibility background backgroundAttachment backgroundBlendMode backgroundClip backgroundColor backgroundImage backgroundOrigin backgroundPosition backgroundPositionX backgroundPositionY backgroundRepeat backgroundRepeatX backgroundRepeatY backgroundSize baselineShift border borderBottom borderBottomColor borderBottomLeftRadius borderBottomRightRadius borderBottomStyle borderBottomWidth borderCollapse borderColor borderImage borderImageOutset borderImageRepeat borderImageSlice borderImageSource borderImageWidth borderLeft borderLeftColor borderLeftStyle borderLeftWidth borderRadius borderRight borderRightColor borderRightStyle borderRightWidth borderSpacing borderStyle borderTop borderTopColor borderTopLeftRadius borderTopRightRadius borderTopStyle borderTopWidth borderWidth bottom boxShadow boxSizing bufferedRendering captionSide clear clip clipPath clipRule color colorInterpolation colorInterpolationFilters colorRendering content counterIncrement counterReset cssFloat cursor cx cy direction display dominantBaseline emptyCells fill fillOpacity fillRule filter flex flexBasis flexDirection flexFlow flexGrow flexShrink flexWrap float floodColor floodOpacity font fontFamily fontFeatureSettings fontKerning fontSize fontStretch fontStyle fontVariant fontVariantLigatures fontWeight height imageRendering isolation justifyContent left letterSpacing lightingColor lineHeight listStyle listStyleImage listStylePosition listStyleType margin marginBottom marginLeft marginRight marginTop marker markerEnd markerMid markerStart mask maskType maxHeight maxWidth maxZoom minHeight minWidth minZoom mixBlendMode motion motionOffset motionPath motionRotation objectFit objectPosition opacity order orientation orphans outline outlineColor outlineOffset outlineStyle outlineWidth overflow overflowWrap overflowX overflowY padding paddingBottom paddingLeft paddingRight paddingTop page pageBreakAfter pageBreakBefore pageBreakInside paintOrder perspective perspectiveOrigin pointerEvents position quotes r resize right rx ry shapeImageThreshold shapeMargin shapeOutside shapeRendering size speak src stopColor stopOpacity stroke strokeDasharray strokeDashoffset strokeLinecap strokeLinejoin strokeMiterlimit strokeOpacity strokeWidth tabSize tableLayout textAlign textAlignLast textAnchor textCombineUpright textDecoration textIndent textOrientation textOverflow textRendering textShadow textTransform top touchAction transform transformOrigin transformStyle transition transitionDelay transitionDuration transitionProperty transitionTimingFunction unicodeBidi unicodeRange userZoom vectorEffect verticalAlign visibility whiteSpace widows width willChange wordBreak wordSpacing wordWrap writingMode x y zIndex zoom'.split(/\s+/);

  dashedProps = {};

  allCssProps.map(function (prop) {
    return dashedProps[prop] = prop.replace(/[A-Z]/mg, function (letter) {
      return '-' + letter.toLowerCase();
    });
  });

  module.exports = Style = function () {
    var Style = function (_EventEmitter) {
      _inherits(Style, _EventEmitter);

      function Style(node) {
        _classCallCheck(this, Style);

        var _this = _possibleConstructorReturn(this, (Style.__proto__ || Object.getPrototypeOf(Style)).call(this));

        _this.setProperty = _this.setProperty.bind(_this);
        _this.node = node;
        _this.cssText = '';
        _this.$settedProps = [];
        return _possibleConstructorReturn(_this);
      }

      _createClass(Style, [{
        key: 'setProperty',
        value: function setProperty(prop, value) {
          var cssText, i, index, len, ref;
          boundMethodCheck(this, Style);
          index = this.$settedProps.indexOf(prop);
          if (value) {
            if (index === -1) {
              this.$settedProps.push(prop);
            }
          } else {
            if (index !== -1) {
              this.$settedProps.splice(index, 1);
            }
          }
          cssText = '';
          ref = this.$settedProps;
          for (i = 0, len = ref.length; i < len; i++) {
            prop = ref[i];
            cssText += dashedProps[prop] + ': ' + this[prop] + '; ';
          }
          this.cssText = cssText;
          this.node.attr('style', this.cssText);
        }
      }, {
        key: 'toString',
        value: function toString() {
          return this.cssText;
        }
      }]);

      return Style;
    }(EventEmitter);

    ;

    allCssProps.forEach(function (prop) {
      var privatePropName;
      privatePropName = '_' + prop;
      return Object.defineProperty(Style.prototype, prop, {
        configurable: true,
        enumerable: true,
        set: function set(value) {
          value = String(value);
          this[privatePropName] = value;
          this.setProperty(prop, value);
          return value;
        },
        get: function get() {
          var ref;
          return (ref = this[privatePropName]) != null ? ref : '';
        }
      });
    });

    return Style;
  }();
}).call(undefined);