'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _global = require('../core/global');

var _global2 = _interopRequireDefault(_global);

var _element = require('./nodes/element');

var _element2 = _interopRequireDefault(_element);

var _comment = require('./nodes/comment');

var _comment2 = _interopRequireDefault(_comment);

var _text = require('./nodes/text');

var _text2 = _interopRequireDefault(_text);

var _node = require('./nodes/node');

var _node2 = _interopRequireDefault(_node);

var _htmlParser = require('./core/html-parser');

var _htmlParser2 = _interopRequireDefault(_htmlParser);

var _textarea = require('./nodes/textarea');

var _textarea2 = _interopRequireDefault(_textarea);

var _input = require('./nodes/input');

var _input2 = _interopRequireDefault(_input);

var _img = require('./nodes/img');

var _img2 = _interopRequireDefault(_img);

var _select = require('./nodes/select');

var _select2 = _interopRequireDefault(_select);

var _context = require('../core/context');

var _context2 = _interopRequireDefault(_context);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var DOM;

module.exports = DOM = function () {
  var DOM = function () {
    function DOM() {
      _classCallCheck(this, DOM);
    }

    _createClass(DOM, null, [{
      key: 'getById',
      value: function getById(nodeId) {
        return _node2.default.createdNodes[nodeId] || null;
      }
    }, {
      key: 'createElement',
      value: function createElement(type) {
        var attrs = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
        var html = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;

        var Constructor, element;
        Constructor = this.elements[type] || _element2.default;
        element = new Constructor(type, attrs);
        if (html) {
          element.html(html);
        }
        return element;
      }
    }, {
      key: 'createText',
      value: function createText(text) {
        return new _text2.default(text);
      }
    }, {
      key: 'createComment',
      value: function createComment(text) {
        return new _comment2.default(text);
      }
    }, {
      key: 'registerElement',
      value: function registerElement(type, Constructor) {
        this.elements[type] = Constructor;
      }
    }, {
      key: 'parse',
      value: function parse(html) {
        if (this.htmlParser == null) {
          this.htmlParser = new _htmlParser2.default();
        }
        return this.htmlParser.parse(html);
      }
    }, {
      key: 'on',
      value: function on(event, handler) {
        var _this = this;

        handler = _context2.default.wrap(handler);
        _global2.default.addEventListener(event, handler, true);
        _context2.default.destroy(function () {
          return _this.off(event, handler);
        });
      }
    }, {
      key: 'off',
      value: function off(event, handler) {
        _global2.default.removeEventListener(event, handler, true);
      }
    }, {
      key: 'one',
      value: function one(event, handler) {
        var dom, _wrapper;
        dom = this;
        _wrapper = function wrapper() {
          var returns;
          returns = handler.apply(this, arguments);
          dom.off(event, _wrapper);
          return returns;
        };
        this.on(event, _wrapper);
      }
    }]);

    return DOM;
  }();

  ;

  DOM.elements = {
    'textarea': _textarea2.default,
    'select': _select2.default,
    'input': _input2.default,
    'img': _img2.default
  };

  return DOM;
}();