'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

(function () {
  var Element, Input;

  Element = require('./element');

  module.exports = Input = function () {
    var Input = function (_Element) {
      _inherits(Input, _Element);

      function Input() {
        _classCallCheck(this, Input);

        var _this = _possibleConstructorReturn(this, (Input.__proto__ || Object.getPrototypeOf(Input)).apply(this, arguments));

        _this.value = '';
        _this.type = _this.attr('type');
        _this.multiple_ = _this.attr('multiple');
        _this.selectionStart_ = 0;
        _this.selectionEnd_ = 0;
        return _possibleConstructorReturn(_this);
      }

      _createClass(Input, [{
        key: 'setSelectionStart',
        value: function setSelectionStart(value) {
          if (this.selectionStart_ !== value) {
            this.selectionStart_ = value;
            this.mutate('changeInput');
          }
        }
      }, {
        key: 'setSelectionEnd',
        value: function setSelectionEnd(value) {
          if (this.selectionEnd_ !== value) {
            this.selectionEnd_ = value;
            this.mutate('changeInput');
          }
        }
      }, {
        key: 'setMultiple',
        value: function setMultiple(value) {
          this.multiple_ = Boolean(value);
          if (this.multiple_) {
            this.attr('multiple', 'true');
          } else {
            this.removeAttr('multiple');
          }
        }
      }, {
        key: 'reset',
        value: function reset() {
          this.setDefaultValue_();
          this.mutate('changeInput');
        }
      }, {
        key: 'setDefaultValue_',
        value: function setDefaultValue_() {
          switch (this.type_) {
            case 'text':
              this.value = '';
              break;
            case 'password':
              this.value = '';
              break;
            case 'checkbox':
              this.value = false;
              break;
            case 'file':
              if (this.value_ instanceof Array) {
                this.value_.splice(0, this.value_.length);
              } else {
                this.value_ = [];
              }
              this.value = this.value_;
          }
        }
      }, {
        key: 'normalizeType_',
        value: function normalizeType_(type) {
          if (type !== 'text' && type !== 'password' && type !== 'checkbox' && type !== 'file') {
            type = 'text';
          }
          return type;
        }
      }, {
        key: 'setType',
        value: function setType(type) {
          this.type_ = this.normalizeType_(type);
          this.setDefaultValue_();
          this.attr('type', this.type_);
        }
      }, {
        key: 'setValueFromRealNode',
        value: function setValueFromRealNode(realNode) {
          if (realNode.type === 'file') {
            var _value_;

            (_value_ = this.value_).splice.apply(_value_, [0, this.value_.length].concat(_toConsumableArray(realNode.files)));
          } else if (realNode.type === 'checkbox') {
            this.value = realNode.checked;
          } else {
            this.value = realNode.value;
            this.selectionStart = realNode.selectionStart;
            this.selectionEnd = realNode.selectionEnd;
          }
        }
      }, {
        key: 'setValue',
        value: function setValue(value) {
          switch (this.type) {
            case 'checkbox':
              value = Boolean(value);
              break;
            case 'file':
              return;
            default:
              value = String(value);
          }
          if (!ui.equals(this.value_, value)) {
            this.value_ = value;
            this.mutate('changeInput');
          }
        }
      }]);

      return Input;
    }(Element);

    ;

    Object.defineProperty(Input.prototype, 'type', {
      set: function set(type) {
        return this.setType(type);
      },
      get: function get() {
        return this.type_;
      },
      configurable: true,
      enumerable: true
    });

    Object.defineProperty(Input.prototype, 'value', {
      set: function set(value) {
        return this.setValue(value);
      },
      get: function get() {
        return this.value_;
      },
      configurable: true,
      enumerable: true
    });

    Object.defineProperty(Input.prototype, 'multiple', {
      set: function set(value) {
        return this.setMultiple(value);
      },
      get: function get() {
        return this.multiple_;
      },
      configurable: true,
      enumerable: true
    });

    Object.defineProperty(Input.prototype, 'selectionStart', {
      set: function set(value) {
        return this.setSelectionStart(value);
      },
      get: function get() {
        return this.selectionStart_;
      },
      configurable: true,
      enumerable: true
    });

    Object.defineProperty(Input.prototype, 'selectionEnd', {
      set: function set(value) {
        return this.setSelectionEnd(value);
      },
      get: function get() {
        return this.selectionEnd_;
      },
      configurable: true,
      enumerable: true
    });

    return Input;
  }();
}).call(undefined);