'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

(function () {
  var EventEmitter,
      MutationObserver,
      Node,
      boundMethodCheck = function boundMethodCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new Error('Bound instance method accessed before binding');
    }
  };

  EventEmitter = require('../../core/event-emitter');

  MutationObserver = require('../core/mutation-observer');

  module.exports = Node = function () {
    var Node = function (_EventEmitter) {
      _inherits(Node, _EventEmitter);

      function Node() {
        _classCallCheck(this, Node);

        var _this = _possibleConstructorReturn(this, (Node.__proto__ || Object.getPrototypeOf(Node)).call(this));

        _this.observe = _this.observe.bind(_this);
        _this.destroy = _this.destroy.bind(_this);
        _this.destroyed = false;
        _this.inited = false;
        _this.nodeId = Node.lastId++;
        _this.observer = null;
        _this.parent = null;
        _this.children = [];
        Node.createdNodes[_this.nodeId] = _this;
        return _possibleConstructorReturn(_this);
      }

      _createClass(Node, [{
        key: 'observe',
        value: function observe() {
          boundMethodCheck(this, Node);
          return this.observer = new MutationObserver();
        }
      }, {
        key: 'init',
        value: function init() {
          if (this.inited) {
            return;
          }
          this.inited = true;
          this.emit('init');
        }
      }, {
        key: 'destroy',
        value: function destroy() {
          var child, i, len, ref, ref1;
          boundMethodCheck(this, Node);
          if (this.destroyed) {
            return;
          }
          this.destroyed = true;
          ref = this.children;
          for (i = 0, len = ref.length; i < len; i++) {
            child = ref[i];
            child.destroy();
          }
          if ((ref1 = this.shadowRoot) != null) {
            ref1.destroy();
          }
          this.emit('destroy');
        }
      }, {
        key: 'mutate',
        value: function mutate(type) {
          var observer;
          observer = this.getObserver();
          if (observer != null) {
            observer.mutate(this, type);
          }
          this.emit('mutate-' + type);
        }
      }, {
        key: 'getObserver',
        value: function getObserver() {
          var node;
          node = this;
          while (node) {
            if (node.observer) {
              return node.observer;
            }
            node = node.parent || node.host;
          }
          return null;
        }
      }, {
        key: 'clone',
        value: function clone() {
          throw Error('Node clone is a pure virtual method');
        }
      }, {
        key: 'remove',
        value: function remove() {
          var needsDestroy = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

          var ref;
          if (needsDestroy) {
            this.destroy();
          }
          if ((ref = this.parent) != null) {
            ref.removeChild(this);
          }
        }
      }, {
        key: 'getIndex',
        value: function getIndex() {
          return this.parent.getChildIndex(this);
        }
      }, {
        key: 'append',
        value: function append(node) {
          node.remove();
          node.parent = this;
          this.children.push(node);
          this.mutate('changeChildren');
        }
      }, {
        key: 'appendTo',
        value: function appendTo(node) {
          node.append(this);
        }
      }, {
        key: 'prepend',
        value: function prepend(node) {
          node.remove();
          node.parent = this;
          this.children.unshift(node);
          this.mutate('changeChildren');
        }
      }, {
        key: 'prependTo',
        value: function prependTo(node) {
          node.append(this);
        }
      }, {
        key: 'insertBefore',
        value: function insertBefore(relChild, node) {
          var index;
          node.remove();
          node.parent = this;
          index = relChild.getIndex();
          this.children.splice(index, 0, node);
          this.mutate('changeChildren');
        }
      }, {
        key: 'before',
        value: function before(node) {
          this.parent.insertBefore(this, node);
        }
      }, {
        key: 'insertAfter',
        value: function insertAfter(relChild, node) {
          var arr, i, index, len;
          if (arguments[1] instanceof Array) {
            var _children;

            arr = arguments[1];
            index = relChild.getIndex();
            (_children = this.children).splice.apply(_children, [index + 1, 0].concat(_toConsumableArray(arr)));
            for (i = 0, len = arr.length; i < len; i++) {
              node = arr[i];
              node.remove();
              node.parent = this;
            }
          } else {
            node.remove();
            node.parent = this;
            index = relChild.getIndex();
            this.children.splice(index + 1, 0, node);
          }
          this.mutate('changeChildren');
        }
      }, {
        key: 'after',
        value: function after(node) {
          this.parent.insertAfter(this, node);
        }
      }, {
        key: 'replaceChild',
        value: function replaceChild(child, newChild) {
          this.insertBefore(child, newChild);
          child.remove();
        }
      }, {
        key: 'replace',
        value: function replace(newNode) {
          this.parent.replaceChild(this, newNode);
        }
      }, {
        key: 'empty',
        value: function empty() {
          var child, i, len, ref;
          ref = this.children.slice();
          for (i = 0, len = ref.length; i < len; i++) {
            child = ref[i];
            this.removeChild(child);
          }
        }
      }, {
        key: 'removeChild',
        value: function removeChild(child) {
          var index;
          index = child.getIndex();
          if (index === -1) {
            return;
          }
          this.children.splice(index, 1);
          child.parent = null;
          this.mutate('changeChildren');
        }
      }, {
        key: 'getChildIndex',
        value: function getChildIndex(node) {
          return this.children.indexOf(node);
        }
      }, {
        key: 'hasChild',
        value: function hasChild(node) {
          return node.parent === this;
        }
      }]);

      return Node;
    }(EventEmitter);

    ;

    Node.lastId = 0;

    Node.createdNodes = {};

    return Node;
  }();
}).call(undefined);