'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _frame2 = require('./polyfill/frame');

var _frame3 = _interopRequireDefault(_frame2);

var _timeout2 = require('./polyfill/timeout');

var _timeout3 = _interopRequireDefault(_timeout2);

var _interval2 = require('./polyfill/interval');

var _interval3 = _interopRequireDefault(_interval2);

var _immediate2 = require('./polyfill/immediate');

var _immediate3 = _interopRequireDefault(_immediate2);

var _global = require('./core/global');

var _global2 = _interopRequireDefault(_global);

var _component2 = require('./core/component');

var _component3 = _interopRequireDefault(_component2);

var _directive2 = require('./core/directive');

var _directive3 = _interopRequireDefault(_directive2);

var _promise = require('./core/promise');

var _promise2 = _interopRequireDefault(_promise);

var _audio = require('./core/audio');

var _audio2 = _interopRequireDefault(_audio);

var _eventEmitter = require('./core/event-emitter');

var _eventEmitter2 = _interopRequireDefault(_eventEmitter);

var _context = require('./core/context');

var _context2 = _interopRequireDefault(_context);

var _arrayObserver = require('./data-bind/array-observer');

var _arrayObserver2 = _interopRequireDefault(_arrayObserver);

var _expObserver = require('./data-bind/exp-observer');

var _expObserver2 = _interopRequireDefault(_expObserver);

var _dataBind = require('./data-bind/data-bind');

var _dataBind2 = _interopRequireDefault(_dataBind);

var _exp = require('./data-bind/exp');

var _exp2 = _interopRequireDefault(_exp);

var _draggable = require('./directives/draggable');

var _draggable2 = _interopRequireDefault(_draggable);

var _html2 = require('./directives/html');

var _html3 = _interopRequireDefault(_html2);

var _pre = require('./directives/pre');

var _pre2 = _interopRequireDefault(_pre);

var _for = require('./directives/for');

var _for2 = _interopRequireDefault(_for);

var _if = require('./directives/if');

var _if2 = _interopRequireDefault(_if);

var _dom = require('./dom');

var _dom2 = _interopRequireDefault(_dom);

var _domRenderer = require('./renderers/dom-renderer');

var _domRenderer2 = _interopRequireDefault(_domRenderer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var UI;

module.exports = _global2.default['ui'] = UI = function () {
  var UI = function () {
    function UI() {
      _classCallCheck(this, UI);
    }

    _createClass(UI, null, [{
      key: 'bootstrap',
      value: function bootstrap(MainComponent) {
        var Renderer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _domRenderer2.default;
        var renderOptions = arguments[2];

        var host;
        this.components = this.components.map(function (Class) {
          return _component3.default.create(Class);
        });
        this.directives = this.directives.map(function (Class) {
          return _directive3.default.create(Class);
        });
        MainComponent = _component3.default.create(MainComponent);
        host = _dom2.default.createElement(MainComponent.tag || 'app');
        this.renderer = new Renderer(host, renderOptions);
        MainComponent.init(host);
        this.app = host.component;
        this.renderer.init();
        return this.app;
      }
    }, {
      key: 'getRealNode',
      value: function getRealNode(node) {
        if (!this.renderer) {
          return null;
        }
        return this.renderer.getRealNode(node);
      }
    }, {
      key: 'getVirtualNode',
      value: function getVirtualNode(realNode) {
        if (!this.renderer) {
          return null;
        }
        return this.renderer.getVirtualNode(realNode);
      }
    }, {
      key: 'directive',
      value: function directive(_directive) {
        this.directives.push(_directive);
      }
    }, {
      key: 'component',
      value: function component(_component) {
        this.components.push(_component);
      }
    }, {
      key: 'addPipe',
      value: function addPipe(name, pipe) {
        return _exp2.default.addPipe(name, pipe);
      }
    }, {
      key: 'pipe',
      value: function pipe() {
        return _exp2.default.pipe.apply(_exp2.default, arguments);
      }
    }, {
      key: 'global',
      value: function global(name, value) {
        return this.globals[name] = value;
      }
    }, {
      key: 'watch',
      value: function watch(context, exp, handler, scope) {
        var firstCall = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : true;

        return new _expObserver2.default(context, exp, handler, scope, firstCall);
      }
    }, {
      key: 'watchArray',
      value: function watchArray(arr, handler) {
        return new _arrayObserver2.default(arr, handler);
      }
    }, {
      key: 'diff',
      value: function diff(arr, oldArr) {
        return _arrayObserver2.default.diff(arr, oldArr);
      }
    }, {
      key: 'bind',
      value: function bind(objL, expL, objR, expR, scope) {
        return new _dataBind2.default(objL, expL, objR, expR, scope);
      }
    }, {
      key: 'eval',
      value: function _eval(context, exp, scope) {
        var safeMode = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : true;

        exp = new _exp2.default(exp);
        return exp(context, scope, safeMode);
      }
    }, {
      key: 'get',
      value: function get(context, exp, scope) {
        return this.eval(context, exp, scope);
      }
    }, {
      key: 'set',
      value: function set(context, exp, value, scope) {
        exp = new _exp2.default(exp);
        return exp.set(context, value, scope);
      }
    }, {
      key: 'frame',
      value: function frame(handler) {
        return (0, _frame3.default)(handler);
      }
    }, {
      key: 'interval',
      value: function interval(handler, time) {
        return (0, _interval3.default)(handler, time);
      }
    }, {
      key: 'timeout',
      value: function timeout(handler, time) {
        return (0, _timeout3.default)(handler, time);
      }
    }, {
      key: 'immediate',
      value: function immediate(handler) {
        return (0, _immediate3.default)(handler);
      }
    }, {
      key: 'on',
      value: function on(event, handler) {
        return this.dom.on(event, handler);
      }
    }, {
      key: 'off',
      value: function off(event, handler) {
        return this.dom.off(event, handler);
      }
    }, {
      key: 'one',
      value: function one(event, handler) {
        return this.dom.one(event, handler);
      }
    }, {
      key: 'init',
      value: function init(handler) {
        this.dom.on('DOMContentLoaded', handler);
      }
    }, {
      key: 'resize',
      value: function resize(handler) {
        return this.dom.on('resize', handler);
      }
    }, {
      key: 'isAndroid',
      value: function isAndroid() {
        return navigator.userAgent.match(/Android/i);
      }
    }, {
      key: 'isBlackBerry',
      value: function isBlackBerry() {
        return navigator.userAgent.match(/BlackBerry/i);
      }
    }, {
      key: 'isIOS',
      value: function isIOS() {
        return navigator.userAgent.match(/iPhone|iPad|iPod/i);
      }
    }, {
      key: 'isOperaMini',
      value: function isOperaMini() {
        return navigator.userAgent.match(/Opera Mini/i);
      }
    }, {
      key: 'isWindowsPhone',
      value: function isWindowsPhone() {
        return navigator.userAgent.match(/IEMobile/i);
      }
    }, {
      key: 'isMobile',
      value: function isMobile() {
        return this.isAndroid() || this.isBlackBerry() || this.isIOS() || this.isOperaMini() || this.isWindowsPhone();
      }
    }, {
      key: 'isCordova',
      value: function isCordova() {
        return !!_global2.default.cordova;
      }
    }, {
      key: 'equals',
      value: function equals(a, b) {
        if (a !== a && b !== b) {
          return true;
        }
        return a === b;
      }
    }, {
      key: 'wrap',
      value: function wrap(func) {
        return _context2.default.wrap(func);
      }
    }, {
      key: 'destroy',
      value: function destroy(handler) {
        return _context2.default.destroy(handler);
      }
    }, {
      key: 'audio',
      value: function audio() {
        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        return new (Function.prototype.bind.apply(_audio2.default, [null].concat(args)))();
      }
    }, {
      key: 'html',
      value: function html(_html) {
        return this.dom.parse(_html);
      }
    }, {
      key: 'createElement',
      value: function createElement(tag, attrs, html) {
        return this.dom.createElement(tag, attrs, html);
      }
    }]);

    return UI;
  }();

  ;

  UI.EventEmitter = _eventEmitter2.default;

  UI.Component = _component3.default;

  UI.Promise = _promise2.default;

  UI.directives = [_pre2.default, _for2.default, _if2.default, _html3.default, _draggable2.default];

  UI.components = [];

  UI.pipes = {};

  UI.dom = _dom2.default;

  UI.systemGlobals = Object.create(null);

  UI.globals = Object.create(UI.systemGlobals);

  UI.renderer = null;

  UI.app = null;

  return UI;
}();