'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _context = require('../core/context');

var _context2 = _interopRequireDefault(_context);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Immediate, callback, clearImmediate, fastApply, firstCall, message, setImmediate, slice, storage, uid;

uid = 0;

storage = {};

firstCall = true;

slice = Array.prototype.slice;

message = 'setImmediatePolyfillMessage';

fastApply = function fastApply(args) {
  var func;
  func = args[0];
  switch (args.length) {
    case 1:
      return func();
    case 2:
      return func(args[1]);
    case 3:
      return func(args[1], args[2]);
  }
  return func.apply(window, slice.call(args, 1));
};

callback = function callback(event) {
  var data, key;
  key = event.data;
  data = void 0;
  if (typeof key === 'string' && key.indexOf(message) === 0) {
    data = storage[key];
    if (data) {
      delete storage[key];
      fastApply(data);
    }
  }
};

setImmediate = window.setImmediate || function () {
  var args, id, key;
  id = uid++;
  key = message + id;
  args = slice.call(arguments);
  storage[key] = args;
  if (firstCall) {
    firstCall = false;
    window.addEventListener('message', callback);
  }
  window.postMessage(key, '*');
  return id;
};

clearImmediate = window.clearImmediate || function (id) {
  delete storage[message + id];
};

Immediate = function () {
  function Immediate(handler) {
    var _this = this;

    _classCallCheck(this, Immediate);

    this.id = setImmediate(_context2.default.wrap(handler));
    _context2.default.destroy(function () {
      return _this.stop();
    });
    return;
  }

  _createClass(Immediate, [{
    key: 'stop',
    value: function stop() {
      clearImmediate(this.id);
    }
  }]);

  return Immediate;
}();

module.exports = function (handler) {
  return new Immediate(handler);
};